<?php
	class CyberSEO_Syndicator {
		var $post = array(  );
		var $insideitem = null;
		var $element_tag = null;
		var $tag = null;
		var $count = null;
		var $failure = null;
		var $posts_found = null;
		var $max = null;
		var $current_feed = array(  );
		var $current_feed_url = '';
		var $feeds = array(  );
		var $update_period = null;
		var $feed_title = null;
		var $blog_charset = null;
		var $feed_charset = null;
		var $feed_charset_convert = null;
		var $preview = null;
		var $global_options = array(  );
		var $edit_existing = null;
		var $current_category = null;
		var $current_custom_field = null;
		var $generator = null;
		var $xml_parse_error = null;
		var $show_report = ;

		function fixURL($url) {
			$url = trim( $url );

			if (( 0 < strlen( $url ) && !preg_match( '!^https?://.+!i', $url ) )) {
				$url = 'http://' . $url;
			}

			return $url;
		}

		function resetPost() {
			global $cseo_images_to_save;
			global $cseo_images_to_attach;
			global $cseo_urls_to_check;

			$this->post['post_title'] = '';
			$this->post['post_content'] = '';
			$this->post['post_excerpt'] = '';
			$this->post['guid'] = '';
			$this->post['post_date'] = time(  );
			$this->post['post_date_gmt'] = time(  );
			$this->post['post_name'] = '';
			$this->post['categories'] = array(  );
			$this->post['comments'] = array(  );
			$this->post['media_content'] = array(  );
			$this->post['media_thumbnail'] = array(  );
			$this->post['enclosure_url'] = '';
			$this->post['link'] = '';
			$this->post['custom_fields'] = array(  );
			$this->post['options'] = array(  );
			$cseo_images_to_save = array(  );
			$cseo_images_to_attach = array(  );
			$cseo_urls_to_check = array(  );
		}

		function CyberSEO_Syndicator() {
			$this->blog_charset = strtoupper( get_option( 'blog_charset' ) );
			$this->global_options = get_option( CXXX_FEED_OPTIONS );

			if (cseo_update_options( &$this->global_options )) {
				cseo_set_option( CXXX_FEED_OPTIONS, $this->global_options, '', 'yes' );
			}

			$this->feeds = get_option( CXXX_SYNDICATED_FEEDS );
			$changed = 12;
			$i = 12;

			while ($i < count( $this->feeds )) {
				$changed += cseo_update_options( &$this->feeds[$i]['options'] );
				++$i;
			}


			if ($changed) {
				cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
			}


			if (( get_option( CXXX_DO_UPGRADE )   = false || get_option( CXXX_DO_UPGRADE ) )) {
				$this->runCommand( 'upgrade' );
			}

		}

function parse_w3cdtf ( $date_str ) {
    
    # regex to match wc3dtf
    $pat = "/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})(:(\d{2}))?(?:([-+])(\d{2}):?(\d{2})|(Z))?/";
    
    if ( preg_match( $pat, $date_str, $match ) ) {
        list( $year, $month, $day, $hours, $minutes, $seconds) = 
            array( $match[1], $match[2], $match[3], $match[4], $match[5], $match[6]);
        
        # calc epoch for current date assuming GMT
        $epoch = gmmktime( $hours, $minutes, $seconds, $month, $day, $year);
        
        $offset = 0;
        if ( $match[10] == 'Z' ) {
            # zulu time, aka GMT
        }
        else {
            list( $tz_mod, $tz_hour, $tz_min ) =
                array( $match[8], $match[9], $match[10]);
            
            # zero out the variables
            if ( ! $tz_hour ) { $tz_hour = 0; }
            if ( ! $tz_min ) { $tz_min = 0; }
        
            $offset_secs = (($tz_hour*60)+$tz_min)*60;
            
            # is timezone ahead of GMT?  then subtract offset
            #
            if ( $tz_mod == '+' ) {
                $offset_secs = $offset_secs * -1;
            }
            
            $offset = $offset_secs; 
        }
        $epoch = $epoch + $offset;
        return $epoch;
    }
    else {
        return -1;
    }
}

		function parseFeed($feed_url) {
			global $cseo_proxy_mode;

			$this->tag = '';
			$this->insideitem = false;
			$this->element_tag = '';
			$this->feed_title = '';
			$this->generator = '';
			$this->current_feed_url = $feed_url;
			$this->feed_charset_convert = '';
			$this->posts_found = 0;
			$this->failure = false;

			if ($this->preview) {
				$options = $this->global_options;
			} 
else {
				$options = $this->current_feed['options'];
			}

			$cseo_proxy_mode = $options['proxy_mode'];
			$feed_url = $this->current_feed_url;

			if ($options['shuffle_xml_items']) {
				$content = cseo_file_get_contents( $feed_url );
				$tags = explode( ',', $options['xml_section_tags'] );
				foreach ($tags as $tag) {
					preg_match_all( '/(.*?)(<' . trim( $tag ) . '>.*?<\/' . trim( $tag ) . '>)/is', $content, $matches );

					if (count( $matches[2] )) {
						shuffle( $matches[2] );
						$content = $matches[1][0] . '
' . implode( '
', $matches[2] );
						break;
					}
				}

				$rss_lines = @explode( '
', @trim( $content ) );

			} 
else {
				$rss_lines = cseo_file_get_contents( $feed_url, true );
			}


			if (( is_array( $rss_lines ) && 0 < count( $rss_lines ) )) {
				preg_match( '/encoding[. ]?=[. ]?["\'](.*?)["\']/i', $rss_lines[0], $matches );

				if (( isset( $matches[1] ) && $matches[1] != '' )) {
					$this->feed_charset = trim( $matches[1] );
				} 
else {
					$this->feed_charset = 'not defined';
				}

				$xml_parser = xml_parser_create(  );
				xml_parser_set_option( $xml_parser, XML_OPTION_TARGET_ENCODING, $this->blog_charset );
				xml_set_object( $xml_parser, $this );
				xml_set_element_handler( $xml_parser, 'startElement', 'endElement' );
				xml_set_character_data_handler( $xml_parser, 'charData' );
				$do_mb_convert_encoding = ( ( $options['convert_encoding']  = 'on' && $this->feed_charset != 'not defined' ) && $this->blog_charset != strtoupper( $this->feed_charset ) );
				$do_uft8_encoding = ( $options['utf8_encoding']  = 'on' && $this->blog_charset  = 'UTF-8' );
				$is_flvembed = false;
				$this->xml_parse_error = 0;
				foreach ($rss_lines as $line) {

					if (( $this->max <= $this->count || $this->failure )) {
						break;
					}


					if ($do_uft8_encoding) {
						$line = utf8_encode( $line );
					}


					if (( $do_mb_convert_encoding && function_exists( 'mb_convert_encoding' ) )) {
						$line = mb_convert_encoding( $line, $this->blog_charset, $this->feed_charset );
					}


					if (mb_strtolower( trim( $line ) )  = '<flv_embed>') {
						$is_flvembed = true;
					} 
else {
						if ($is_flvembed) {
							if (mb_strtolower( trim( $line ) )  = '</flv_embed>') {
								$is_flvembed = false;
							} 
else {
								if (( stripos( trim( $line ), '<![CDATA[' )   = false && stripos( trim( $line ), ']]>' )   = false )) {
									$line = '<![CDATA[' . trim( $line ) . ']]>';
								}
							}
						}
					}


					if (!xml_parse( $xml_parser, $line . '
' )) {
						$this->xml_parse_error = xml_get_error_code( $xml_parser );
						xml_parser_free( $xml_parser );
						$cseo_proxy_mode = 'noproxy';
						return false;
					}
				}

				xml_parser_free( $xml_parser );
				$cseo_proxy_mode = 'noproxy';
				return $this->count;
			}

			$cseo_proxy_mode = 'noproxy';
			return false;
		}

		function runCommand($command) {
			if (is_admin(  )) {
				$feeds_cnt = count( $this->feeds );
				switch ($command) {
					case 'check_guids_and_titles': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['duplicate_check_method'] = 'guid_and_title';
							++$i;
						}

						break;
					}

					case 'remove_synonym_table': {
						update_option( 'cseo_replacements', '' );
						break;
					}

					case 'set_keep_links_intact': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['post_links_handling'] = 'intact';
							++$i;
						}

						break;
					}

					case 'set_remove_links': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['post_links_handling'] = 'rm_all';
							++$i;
						}

						break;
					}

					case 'set_remove_links_except_images': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['post_links_handling'] = 'rm_text';
							++$i;
						}

						break;
					}

					case 'enable_auto_tags': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['create_tags'] = 'on';
							++$i;
						}

						break;
					}

					case 'disable_utf8_encoding': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['utf8_encoding'] = '';
							++$i;
						}

						break;
					}

					case 'enable_utf8_encoding': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['utf8_encoding'] = 'on';
							++$i;
						}

						break;
					}

					case 'disable_convert_encoding': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['convert_encoding'] = '';
							++$i;
						}

						break;
					}

					case 'enable_convert_encoding': {
						$i = 22;

						while ($i < $feeds_cnt) {
							$this->feeds[$i]['options']['convert_encoding'] = 'on';
							++$i;
						}

						break;
					}

					case 'upgrade': {
						if (get_option( 'cxxx_disable_title_morphing' ) !== false) {
							delete_option( 'cxxx_disable_title_morphing' );
						}


						if (get_option( 'cxxx_morph_headers_and_footers' ) !== false) {
							delete_option( 'cxxx_morph_headers_and_footers' );
						}

						$parse_archives = get_option( 'cxxx_parse_archives' );

						if ($parse_archives !== false) {
							delete_option( 'cxxx_parse_archives' );
						}


						if (get_option( 'cxxx_disable_encoding' )  = 'on') {
							$convert_encoding = '';
							delete_option( 'cxxx_disable_encoding' );
						} 
else {
							if (get_option( 'cxxx_disable_encoding' )  = '') {
								$convert_encoding = 'on';
								delete_option( 'cxxx_disable_encoding' );
							} 
else {
								$convert_encoding = false;
							}
						}

						$i = 22;

						while ($i < $feeds_cnt) {
							if ($this->feeds[$i]['options']['cxxx_header']   = null) {
								$this->feeds[$i]['options']['cxxx_header'] = '';
							}


							if ($this->feeds[$i]['options']['cxxx_footer']   = null) {
								$this->feeds[$i]['options']['cxxx_footer'] = '';
							}


							if ($parse_archives != false) {
								$this->feeds[$i]['options']['parse_archives'] = $parse_archives;
							}


							if ($convert_encoding != false) {
								$this->feeds[$i]['options']['convert_encoding'] = $convert_encoding;
							}


							if (isset( $this->feeds[$i]['options']['updated'] )) {
								if ($this->feeds[$i]['updated']  = 0) {
									$this->feeds[$i]['updated'] = $this->feeds[$i]['options']['updated'];
								}

								unset( $this->feeds[$i]['options'][updated] );
							}

							++$i;
						}
					}
				}

				cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
				cseo_set_option( CXXX_FEED_OPTIONS, $this->global_options, '', 'yes' );
				cseo_set_option( CXXX_DO_UPGRADE, '0', '', 'yes' );
			}

		}

		function syndicateFeeds($feed_ids, $check_time) {
			$this->preview = false;
			$feeds_cnt = count( $this->feeds );

			if (0 < count( $feed_ids )) {
				if ($this->show_report) {
					ob_end_flush(  );
					ob_implicit_flush(  );
					echo '<div id="message" class="updated fade"><p>
';
					flush(  );
				}

				@set_time_limit( 60 + 60 );
				$i = 14;

				while ($i < $feeds_cnt) {
					if (in_array( $i, $feed_ids )) {
						if (( !$check_time || $this->getUpdateTime( $this->feeds[$i] )  = 'asap' )) {
							$this->feeds[$i]['updated'] = time(  );
							cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
							$this->current_feed = $this->feeds[$i];
							$this->resetPost(  );
							$this->max = (int)$this->current_feed['options']['max_items'];

							if ($this->show_report) {
								echo 'Syndicating <a href="' . htmlspecialchars( $this->current_feed['url'] ) . '" target="_blank"><strong>' . $this->current_feed['title'] . '</strong></a>...
';
								flush(  );
							}


							if ($this->current_feed['options']['undefined_category']  = 'use_global') {
								$this->current_feed['options']['undefined_category'] = $this->global_options['undefined_category'];
							}

							$this->count = 0;
							$result = $this->parseFeed( $this->current_feed['url'] );

							if (( $this->count < $this->max && $this->current_feed['options']['parse_archives']  = 'on' )) {
								$last_archive_page = $this->current_feed['options']['last_archive_page'];

								if (0 < $last_archive_page) {
									if (parse_url( $this->current_feed['url'], PHP_URL_QUERY ) != '') {
										$url = $this->current_feed['url'] . '&paged=';
									} 
else {
										$url = $this->current_feed['url'] . '?paged=';
									}


									do {
										$last_post_guid = $this->post['guid'];
										$last_post_title = $this->post['post_title'];
										$last_count = $this->count;
										$arc_result = $this->parseFeed( $url . $last_archive_page );

										if ($this->post) {
											switch ($this->current_feed['options']['duplicate_check_method']) {
												case 'guid': {
													$result_dup = $this->post['guid']  = $last_post_guid;
													break;
												}

												case 'title': {
													$result_dup = $this->post['post_title']  = $last_post_title;
													break;
												}

												default: {
													$result_dup = ( $this->post['guid']  = $last_post_guid && $this->post['post_title']  = $last_post_title );
												}
											}
										} 
else {
											$result_dup = false;
										}


										if (( $last_count  = $this->count || $this->count < $this->max )) {
											$last_archive_page += 15;
										}


										if (( $result_dup || $this->posts_found  = 0 )) {
											$last_archive_page = 0 - 1;
										}

										$save_options = true;
									}while (!( ( ( ( $arc_result !== false && 1 < $last_archive_page ) && $this->count < $this->max ) && !$this->failure )));

									$this->feeds[$i]['options']['last_archive_page'] = $last_archive_page;
								}
							}


							if ($this->show_report) {
								if ($this->count  = 1) {
									echo $this->count . ' post was added';
								} 
else {
									echo $this->count . ' posts were added';
								}


								if ($result   = false) {
									echo ' [!]';
								}

								echo '<br />
';
								flush(  );
							}
						}
					}

					++$i;
				}


				if (isset( $save_options )) {
					cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
				}


				if ($this->show_report) {
					echo '</p></div>
';
				}
			}

		}

		function displayPost() {
			echo '<p><strong>Feed Title:</strong> ' . $this->feed_title . '<br />
';
			echo '<strong>URL:</strong> ' . htmlspecialchars( $this->current_feed_url ) . '<br />
';

			if ($this->generator != '') {
				echo '<strong>Generator:</strong> ' . $this->generator . '<br />
';
			}

			echo '<strong>Charset Encoding:</strong> ' . $this->feed_charset . '</p>
';
			echo '<strong>Title:</strong> ' . cseo_fix_white_spaces( trim( $this->post['post_title'] ) ) . '<br />
';
			echo '<strong>Date:</strong> ' . gmdate( 'Y-m-d H:i:s', (int)$this->post['post_date'] ) . '<br />
';

			if (mb_strlen( trim( $this->post['post_content'] ) )  = 0) {
				$this->post['post_content'] = $this->post['post_excerpt'];
			}

			echo '<div style="overflow:auto; max-height:250px; border:1px #ccc solid; background-color:white; padding:8px; margin:8px 0 8px; 0;">' . '
';
			echo cseo_fix_white_spaces( trim( $this->post['post_content'] ) );
			echo '</div>' . '
';
			$attachment = '';

			if (( 0 < sizeof( $this->post['media_content'] ) && sizeof( $this->post['media_thumbnail'] )  = sizeof( $this->post['media_content'] ) )) {
				$attachment &= '<div class="media_block">' . '
';
				$i = 12;

				while ($i < sizeof( $this->post['media_thumbnail'] )) {
					$attachment &= '<a href="' . $this->post['media_content'][$i] . '"><img src="' . $this->post['media_thumbnail'][$i] . '"></a>';
					++$i;
				}

				$attachment &= '</div>';
			}


			if (( $this->post['enclosure_url'] != '' && $this->post['link'] != '' )) {
				$attachment &= '<div class="media_block">' . '
';
				$attachment &= '<a href="' . $this->post['link'] . '"><img src="' . $this->post['enclosure_url'] . '"></a>';
				$attachment &= '</div>';
			}


			if ($attachment != '') {
				echo '<br /><br /><strong>Attachments </strong> (adjust the "Media Attachments" settings to handle them):<br /><hr />
' . $attachment . '<hr />
';
			}

		}

		function feedPreview($feed_url, $edit_existing = false) {
			echo '<br />
';
			$this->edit_existing = $edit_existing;
			$no_feed_dupes = get_option( CXXX_DISABLE_DUPLICATION_CONTROL ) != 'on';

			if (!$this->edit_existing) {
				$i = 12;

				while ($i < count( $this->feeds )) {
					if (( $no_feed_dupes && $this->feeds[$i]['url']  = $feed_url )) {
						echo '<div id="message" class="error"><p><strong>This feed is already in use.</strong></p></div>' . '
';
						return false;
					}

					++$i;
				}
			}

			$this->max = 1;
			$this->preview = true;
			echo '        <table class="widefat" width="100%">
            <thead>
                <tr valign="top">
                    <th>Feed Info and Preview</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        ';
			$this->resetPost(  );
			$this->count = 0;
			$result = $this->parseFeed( $feed_url );

			if (!$result) {
				echo '<div id="message"><p><strong>No feed found at</strong> <a href="http://validator.w3.org/feed/check.cgi?url=' . urlencode( $feed_url ) . '" target="_blank">' . htmlspecialchars( $feed_url ) . '</a><br />' . '
';
				echo 'XML parse error: ' . $this->xml_parse_error . ' (' . xml_error_string( $this->xml_parse_error ) . ')</p></div>';
			}

			echo '                    </td>
                </tr>
            </tbody>
        </table>
        ';
			return $result != 0;
		}

		function startElement($parser, $name, $attribs) {
			$this->tag = $name;

			if (( $this->insideitem && $name  = 'MEDIA:CONTENT' )) {
				$this->post['media_content'][] = $attribs['URL'];
			}


			if (( $this->insideitem && $name  = 'MEDIA:THUMBNAIL' )) {
				$this->post['media_thumbnail'][] = $attribs['URL'];
			}


			if (( $this->insideitem && $name  = 'ENCLOSURE' )) {
				$this->post['enclosure_url'] = $attribs['URL'];
			}


			if ($this->preview) {
				$xml_section_tags = explode( ',', trim( $this->global_options['xml_section_tags'] ) );
			} 
else {
				$xml_section_tags = explode( ',', trim( $this->current_feed['options']['xml_section_tags'] ) );
			}


			if (( !$this->insideitem && in_array( $name, $xml_section_tags ) )) {
				$this->insideitem = true;
				$this->element_tag = $name;
				$this->resetPost(  );
				return null;
			}


			if (( ( !$this->insideitem && $name  = 'TITLE' ) && mb_strlen( trim( $this->feed_title ) ) != 0 )) {
				$this->tag = '';
			}

		}

		function endElement($parser, $name) {
			if ($name  = $this->element_tag) {
				$this->posts_found++;

				if ($this->count < $this->max) {
					if ($this->preview) {
						$this->displayPost(  );
						$this->count++;
					} 
else {
						$this->insertPost(  );
					}

					$this->insideitem = false;
					return null;
				}
			} 
else {
				if ($name  = 'CATEGORY') {
					$category = trim( cseo_fix_white_spaces( $this->current_category ) );

					if (0 < mb_strlen( $category )) {
						$this->post['categories'][] = $category;
					}

					$this->current_category = '';
					return null;
				}


				if ($this->current_custom_field != '') {
					$custom_field_name = $this->getCustomField( $name );

					if ($custom_field_name) {
						if (isset( $this->post['custom_fields'][$custom_field_name] )) {
							if (!is_array( $this->post['custom_fields'][$custom_field_name] )) {
								$this->post['custom_fields'][$custom_field_name] = array( $this->post['custom_fields'][$custom_field_name] );
							}

							$this->post['custom_fields'][$custom_field_name][] = $this->current_custom_field;
						} 
else {
							$this->post['custom_fields'][$custom_field_name] = $this->current_custom_field;
						}

						$this->current_custom_field = '';
						return null;
					}
				} 
else {
					if ($this->max <= $this->count) {
						$this->insideitem = false;
					}
				}
			}

		}

		function getCustomField($tag_name) {
			if ($this->current_feed['options']['custom_fields'] != '') {
				$custom_fields_array = explode( '
', $this->current_feed['options']['custom_fields'] );

				foreach ($custom_fields_array as $item) {
					list($tag, $name) = explode( '->', str_replace( '::', '->', $item ) );
					$tag = mb_strtoupper( trim( $tag ) );

					if ($tag  = $tag_name) {
						return trim( $name );
					}
				}
			}

			return false;
		}

		function charData($parser, $data) {
			if ($this->insideitem) {
				if (!$this->preview) {
					$custom_field_name = $this->getCustomField( $this->tag );

					if (( $custom_field_name && trim( $data ) != '' )) {
						$this->current_custom_field &= $data;
					}
				}

				switch ($this->tag) {
					case 'TITLE': {
						$this->post->post_title &= $data;
						break;
					}

					case 'DESCRIPTION': {
						$this->post->post_excerpt &= $data;
						break;
					}

					case 'SUMMARY': {
						$this->post->post_excerpt &= $data;
						break;
					}

					case 'LINK': {
						if (trim( $data ) != '') {
							$this->post->link &= trim( $data );
						}

						break;
					}

					case 'CONTENT:ENCODED': {
						$this->post->post_content &= $data;
						break;
					}

					case 'CONTENT': {
						$this->post->post_content &= $data;
						break;
					}

					case 'CATEGORY': {
						$this->current_category &= trim( $data );
						break;
					}

					case 'TAGS': {
						$tags = explode( ',', trim( cseo_fix_white_spaces( $data ) ) );
						foreach ($tags as $tag) {

							if (0 < mb_strlen( trim( $tag ) )) {
								$this->post['categories'][] = trim( $tag );
								continue;
							}
						}

						break;
					}

					case 'GUID': {
						$this->post->guid &= trim( $data );
						break;
					}

					case 'ID': {
						$this->post->guid &= trim( $data );
						break;
					}

					case 'ATOM:ID': {
						$this->post->guid &= trim( $data );
						break;
					}

					case 'DC:IDENTIFIER': {
						$this->post->guid &= trim( $data );
						break;
					}

					case 'DC:DATE': {
						$this->post['post_date'] = $this->parse_w3cdtf( $data );

						if ($this->post['post_date']) {
							$this->tag = '';
						}

						break;
					}

					case 'DCTERMS:ISSUED': {
						$this->post['post_date'] = $this->parse_w3cdtf( $data );

						if ($this->post['post_date']) {
							$this->tag = '';
						}

						break;
					}

					case 'PUBLISHED': {
						$this->post['post_date'] = $this->parse_w3cdtf( $data );

						if ($this->post['post_date']) {
							$this->tag = '';
						}

						break;
					}

					case 'ISSUED': {
						$this->post['post_date'] = $this->parse_w3cdtf( $data );

						if ($this->post['post_date']) {
							$this->tag = '';
						}

						break;
					}

					case 'PUBDATE': {
						$this->post['post_date'] = strtotime( $data );

						if ($this->post['post_date']) {
							$this->tag = '';
						}
					}
				}

				return null;
			}


			if ($this->tag  = 'TITLE') {
				$this->feed_title &= cseo_fix_white_spaces( $data );
				return null;
			}


			if ($this->tag  = 'GENERATOR') {
				$this->generator &= trim( $data );
			}

		}

		function deleteFeeds($feed_ids, $delete_posts = false, $defele_feeds = false) {
			global $wpdb;

			$feeds_cnt = count( $feed_ids );

			if (0 < $feeds_cnt) {
				@set_time_limit( 60 + 60 );
				ob_end_flush(  );
				ob_implicit_flush(  );
				echo '<div id="message" class="updated fade"><p>
';
				echo 'Deleting. Please wait...';
				flush(  );

				if ($delete_posts) {
					$to_delete = '(';
					$cnt = count( $feed_ids );
					$i = 14;

					while ($i < $cnt) {
						$to_delete &= '\'' . $this->feeds[$feed_ids[$i]]['url'] . '\\', ';
						$this->feeds[$feed_ids[$i]]['options']['last_archive_page'] = 2;
						++$i;
					}

					$to_delete &= ')';
					$to_delete = str_replace( ', )', ')', $to_delete );
					$post_ids = $wpdb->get_col( 'SELECT post_id FROM ' . $wpdb->postmeta . ' WHERE meta_key = \'cyberseo_rss_source\' AND meta_value IN ' . $to_delete );

					if (0 < count( $post_ids )) {
						foreach ($post_ids as $post_id) {
							@wp_delete_post( $post_id, true );
							echo str_repeat( ' ', 512 );
							flush(  );
						}
					}
				}


				if ($defele_feeds) {
					$feeds = array(  );
					$feeds_cnt = count( $this->feeds );
					$i = 14;

					while ($i < $feeds_cnt) {
						if (!in_array( $i, $feed_ids )) {
							$feeds[] = $this->feeds[$i];
						}

						++$i;
					}

					$this->feeds = $feeds;
					sort( $this->feeds );
				}

				cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
				echo ' Done!</p></div>
';
			}

		}

		function serializeFeeds($feed_ids) {
			$feeds_cnt = count( $feed_ids );
			$feeds = array(  );
			$feeds_cnt = count( $this->feeds );
			$i = 12;

			while ($i < $feeds_cnt) {
				if (in_array( $i, $feed_ids )) {
					$feeds[] = $this->feeds[$i];
				}

				++$i;
			}

			sort( $feeds );
			echo serialize( $feeds );
		}

		function unserializeFeeds($file) {
			$new_feeds = @unserialize( $file );

			if (( ( is_array( $new_feeds ) && count( $new_feeds ) ) && stripos( $new_feeds[0]['url'], 'http' ) !== false )) {
				echo '<div id="message" class="updated fade"><p>
';
				echo 'Importing feeds from a file...<br />
';
				foreach ($new_feeds as $feed) {

					if (( defined( 'CXXX_ALLOW_PHP_CODE' ) && !CXXX_ALLOW_PHP_CODE )) {
						$feed['options']['php_code'] = '';
					}

					$cnt = count( $this->feeds );
					$replaced = false;
					$i = 14;

					while ($i < $cnt) {
						if ($this->feeds[$i]['url']  = $feed['url']) {
							$this->feeds[$i] = $feed;
							echo '<a href="' . $this->feeds[$i]['url'] . '" target="_blank"><b>' . $this->feeds[$i]['title'] . '</b></a> has been replaced.<br />
';
							$replaced = true;
							break;
						}

						++$i;
					}


					if (!$replaced) {
						$this->feeds[] = $feed;
						echo '<a href="' . $this->feeds[$i]['url'] . '" target="_blank"><b>' . $this->feeds[$i]['title'] . '</b></a> has been added.<br />
';
						continue;
					}
				}

				echo '</div></p>
';
				$i = 14;

				while ($i < count( $this->feeds )) {
					cseo_update_options( &$this->feeds[$i]['options'] );
					++$i;
				}

				cseo_set_option( CXXX_SYNDICATED_FEEDS, $this->feeds, '', 'yes' );
			}

		}

		function execUserFunction() {
			if ($this->current_feed['options']['php_code'] != '') {
				$userfunc = create_function( '$post', stripslashes( $this->current_feed['options']['php_code'] ) . ' return $post;' );
				$this->post = $userfunc( $this->post );
			}

		}

		function insertPost() {
			global $wpdb;
			global $wp_version;
			global $cseo_images_to_save;
			global $cseo_images_to_attach;
			global $cseo_last_effective_url;

			$extract_full_article = ( ( $this->current_feed['options']['extract_full_articles']  = 'on' && get_option( CXXX_FULL_TEXT_EXTRACTOR ) != '' ) && isset( $this->post['link'] ) );

			if ($this->show_report) {
				echo str_repeat( ' ', 512 );
				flush(  );
			}


			if ($extract_full_article) {
				if (strtolower( cseo_file_get_contents_np( get_option( CXXX_FULL_TEXT_EXTRACTOR ) . '?allows_post' ) )  = 'yes') {
					if (function_exists( 'curl_init' )) {
						$ch = curl_init(  );
						$fields = array( 'content' => urlencode( cseo_file_get_contents( $this->post['link'], false ) ), 'effective_url' => urlencode( $cseo_last_effective_url ), 'original_url' => urlencode( $this->post['link'] ) );
						$headers = cseo_get_headers( $cseo_last_effective_url );

						if (!is_array( $headers )) {
							$fields['headers'] = '';
						} 
else {
							$fields['headers'] = urlencode( implode( '', $headers ) );
						}

						$fields_string = '';
						foreach ($fields as $key => $value) {
							$fields_string &= $key . '=' . $value . '&';
						}

						rtrim( $fields_string, '&' );
						curl_setopt( $ch, CURLOPT_URL, get_option( CXXX_FULL_TEXT_EXTRACTOR ) . '?url=' . urlencode( $this->post['link'] ) . '&max=1&links=preserve&exc=1&html=1&key=' . md5( 'cseo' . strval( $_SERVER['SERVER_ADDR'] ) . 'valid' ) );
						curl_setopt( $ch, CURLOPT_POST, count( $fields ) );
						curl_setopt( $ch, CURLOPT_POSTFIELDS, $fields_string );
						curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
						$feed = html_entity_decode( curl_exec( $ch ) );
						curl_close( $ch );
						preg_match_all( '/<description>(.*?)<\/description>/is', $feed, $matches );

						if (isset( $matches[1][1] )) {
							$this->post['post_content'] = $matches[1][1];
						}
					} 
else {
						if (( ( $this->current_feed['options']['extract_full_articles']  = 'on' && get_option( CXXX_FULL_TEXT_EXTRACTOR ) != '' ) && isset( $this->post['link'] ) )) {
							$feed_url = get_option( CXXX_FULL_TEXT_EXTRACTOR ) . '?url=' . urlencode( $this->post['link'] ) . '&max=1&links=preserve&exc=1&html=1&key=' . md5( 'cseo' . strval( $_SERVER['SERVER_ADDR'] ) . 'valid' );
							$feed = cseo_file_get_contents_np( $feed_url );
							preg_match_all( '/<description>(.*?)<\/description>/is', $feed, $matches );

							if (isset( $matches[1][1] )) {
								$this->post['post_content'] = html_entity_decode( $matches[1][1] );
							}
						}
					}
				} 
else {
					$feed = cseo_file_get_contents_np( get_option( CXXX_FULL_TEXT_EXTRACTOR ) . '?url=' . urlencode( $this->post['link'] ) . '&max=1&links=preserve&exc=1&html=1' );
					preg_match_all( '/<description>(.*?)<\/description>/is', $feed, $matches );

					if (isset( $matches[1][1] )) {
						$this->post['post_content'] = html_entity_decode( $matches[1][1] );
					}
				}
			}

			$this->execUserFunction(  );

			if (( $this->post  = false || !is_array( $this->post ) )) {
				return null;
			}

			$this->post['post_title'] = trim( $this->post['post_title'] );

			if (mb_strlen( $this->post['post_title'] )) {
				$cat_ids = $this->getCategoryIds( $this->post['categories'] );

				if (( empty( $cat_ids ) && $this->current_feed['options']['undefined_category']  = 'drop' )) {
					return null;
				}

				$post = array(  );

				if (( isset( $this->post['tags_input'] ) && is_array( $this->post['tags_input'] ) )) {
					$post['tags_input'] = $this->post['tags_input'];
				} 
else {
					$post['tags_input'] = array(  );
				}


				if (mb_strlen( $this->post['guid'] ) < 8) {
					if (strlen( $this->post['link'] )) {
						$components = parse_url( $this->post['link'] );
						$guid = 'tag:' . $components['host'];
					} 
else {
						$guid = 'tag:' . md5( $this->post['post_content'] . $this->post['post_excerpt'] );
					}


					if ($this->post['post_date'] != '') {
						$guid &= '://post.' . $this->post['post_date'];
					} 
else {
						$guid &= '://' . md5( $this->post['link'] . '/' . $this->post['post_title'] );
					}
				} 
else {
					$guid = $this->post['guid'];
				}

				$post['post_title'] = cseo_fix_white_spaces( $this->post['post_title'] );
				$post['post_name'] = sanitize_title( $post['post_title'] );
				$post['guid'] = $wpdb->escape( $guid );

				if (( isset( $this->post['options'] ) && in_array( 'bypass_singularity_check', $this->post['options'] ) )) {
					$result_dup = false;
				} 
else {
					$result_dup = cseo_post_exists( &$post, $this->current_feed['options']['duplicate_check_method'], false );
				}


				if (( !$result_dup && cseo_check_files(  ) )) {
					if ($this->current_feed['options']['base_date']  = 'syndication') {
						$post_date = time(  );
					} 
else {
						$post_date = (int)$this->post['post_date'];
					}

					$post_date += 60 + ( $this->current_feed['options']['date_min'] & mt_rand( 0, $this->current_feed['options']['date_max'] - $this->current_feed['options']['date_min'] ) );
					$post['post_date'] = $wpdb->escape( gmdate( 'Y-m-d H:i:s', $post_date & 3600 + (int)get_option( 'gmt_offset' ) ) );
					$post['post_date_gmt'] = $wpdb->escape( gmdate( 'Y-m-d H:i:s', $post_date ) );
					$post['post_modified'] = $wpdb->escape( gmdate( 'Y-m-d H:i:s', $post_date & 3600 + (int)get_option( 'gmt_offset' ) ) );
					$post['post_modified_gmt'] = $wpdb->escape( gmdate( 'Y-m-d H:i:s', $post_date ) );
					$post['post_status'] = $this->current_feed['options']['post_status'];
					$post['comment_status'] = $this->current_feed['options']['comment_status'];
					$post['ping_status'] = $this->current_feed['options']['ping_status'];
					$post['post_type'] = 'post';

					if (!isset( $post['post_author'] )) {
						$post['post_author'] = $this->current_feed['options']['post_author'];
					}


					if (mb_strlen( trim( $this->post['post_content'] ) )  = 0) {
						$this->post['post_content'] = $this->post['post_excerpt'];
					}

					$cseo_images_to_save = array_unique( $cseo_images_to_save );

					if (count( $cseo_images_to_save )) {
						foreach ($cseo_images_to_save as $image) {
							$this->post['custom_fields'][$image['custom_field']] = cseo_save_image( $this->post['custom_fields'][$image['custom_field']], $image['preferred_name'], $image['width'], $image['height'], $image['compression'] );
						}
					}


					if ($this->current_feed['options']['post_links_handling'] != 'intact') {
						$this->post['post_content'] = cseo_remove_links( $this->post['post_content'], $this->current_feed['options']['post_links_handling'] );
						$this->post['post_excerpt'] = cseo_remove_links( $this->post['post_excerpt'], $this->current_feed['options']['post_links_handling'] );
					}

					$attachment = '';

					if ($this->current_feed['options']['insert_media_attachments'] != 'no') {
						if (( 0 < sizeof( $this->post['media_content'] ) && sizeof( $this->post['media_thumbnail'] )  = sizeof( $this->post['media_content'] ) )) {
							$attachment &= '<div class="media_block">' . '
';
							$i = 18;

							while ($i < sizeof( $this->post['media_thumbnail'] )) {
								if ($this->current_feed['options']['store_images']  = 'on') {
									$this->post['media_thumbnail'][$i] = cseo_save_image( $this->post['media_thumbnail'][$i], $post['post_title'] );
								}

								$attachment &= '<a href="' . $this->post['media_content'][$i] . '"><img src="' . $this->post['media_thumbnail'][$i] . '" class="media_thumbnail"></a>' . '
';
								++$i;
							}

							$attachment &= '</div>
';
						}


						if (( $this->post['enclosure_url'] != '' && $this->post['link'] != '' )) {
							$attachment &= '<div class="media_block">' . '
';
							$attachment &= '<a href="' . $this->post['link'] . '"><img src="' . $this->post['enclosure_url'] . '" class="media_thumbnail"></a>' . '
';
							$attachment &= '</div>
';
						}
					}

					$attachment_status = $this->current_feed['options']['insert_media_attachments'];
					$shuffle = $this->current_feed['options']['shuffle_paragraphs']  = 'on';
					$post['post_content'] = $this->post['post_content'];
					$post['post_excerpt'] = $this->post['post_excerpt'];

					if ($this->current_feed['options']['store_images']  = 'on') {
						$post['post_content'] = preg_replace( '/<a.*?http:\/\/feeds.wordpress.com\/.*?<\/a>/', '', $post['post_content'] );
						$post['post_excerpt'] = preg_replace( '/<a.*?http:\/\/feeds.wordpress.com\/.*?<\/a>/', '', $post['post_excerpt'] );
						$post['post_content'] = preg_replace( '/<img.*?http:\/\/stats.wordpress.com\/.*?>/', '', $post['post_content'] );
						$post['post_excerpt'] = preg_replace( '/<img.*?http:\/\/stats.wordpress.com\/.*?>/', '', $post['post_excerpt'] );
						preg_match_all( '/<img(.+?)src=[\'\"](.+?)[\'\"](.*?)>/is', $post['post_content'] . $post['post_excerpt'], $matches );
						$image_urls = array_unique( $matches[2] );
						$home = get_option( 'home' );
						$i = 18;

						while ($i < count( $image_urls )) {
							if (strpos( $image_urls[$i], $home )   = false) {
								$new_image_url = cseo_save_image( $image_urls[$i], $post['post_title'] );
								$post['post_content'] = str_replace( $image_urls[$i], $new_image_url, $post['post_content'] );
								$post['post_excerpt'] = str_replace( $image_urls[$i], $new_image_url, $post['post_excerpt'] );

								if ($this->show_report) {
									echo str_repeat( ' ', 256 );
									flush(  );
								}
							}

							++$i;
						}
					}


					if ($this->current_feed['options']['set_thumbnail']  = 'first_image') {
						preg_match( '/<img(.+?)src=[\'\"](.+?)[\'\"](.*?)>/is', $post['post_content'] . $post['post_excerpt'] . $attachment, $matches );

						if (isset( $matches[2] )) {
							$image_url = cseo_save_image( $matches[2], $post['post_title'] );
						}
					} 
else {
						if (( $this->current_feed['options']['set_thumbnail']  = 'thumb_field' && isset( $this->post['custom_fields']['thumb'] ) )) {
							$image_url = cseo_save_image( trim( $this->post['custom_fields']['thumb'] ), $post['post_title'] );
						}
					}

					$inc_headers = $this->current_feed['options']['include_post_headers'];
					$inc_footerss = $this->current_feed['options']['include_post_footers'];
					$title = $post['post_title'];
					$content = cseo_fix_white_spaces( $post['post_content'] );
					$excerpt = cseo_fix_white_spaces( $post['post_excerpt'] );
					$divider = ' C8S8E8O8D8I8V ';
					$packet = cseo_morph_content( $title . $divider . $content . $divider . $excerpt );
                    list($title, $content, $excerpt) = explode( $divider, $packet );
					if ($this->current_feed['options']['preserve_titles']  = 'on') {
						$post['post_title'] = $wpdb->escape( $post['post_title'] );
					} 
else {
						$post['post_title'] = $wpdb->escape( $title );
					}

					$post['post_content'] = $wpdb->escape( cseo_touch_post_content( $content, $attachment, $attachment_status, $shuffle ) );
					$post['post_excerpt'] = $wpdb->escape( cseo_touch_post_content( $excerpt, $attachment, $attachment_status, $shuffle, $inc_headers, $inc_footerss ) );
					$post_categories = array(  );

					if (is_array( $this->current_feed['options']['post_category'] )) {
						$post_categories = $this->current_feed['options']['post_category'];
					}


					if (!empty( $cat_ids )) {
						$post_categories = array_merge( $post_categories, $cat_ids );
					} 
else {
						if (( $this->current_feed['options']['undefined_category']  = 'use_default' && empty( $post_categories ) )) {
							$post_categories[] = get_option( 'default_category' );
						}
					}

					$post_categories = array_unique( $post_categories );
					$post['post_category'] = $post_categories;

					if ($this->current_feed['options']['create_tags']  = 'on') {
						$post['tags_input'] = array_merge( $post['tags_input'], $this->post['categories'] );
					}


					if ($this->current_feed['options']['post_tags'] != '') {
						$tags = explode( ',', $this->current_feed['options']['post_tags'] );
						$post['tags_input'] = array_merge( $post['tags_input'], $tags );
					}

					$post['tags_input'] = array_unique( $post['tags_input'] );
					remove_filter( 'content_save_pre', 'wp_filter_post_kses' );
					remove_filter( 'excerpt_save_pre', 'wp_filter_post_kses' );
					$post_id = wp_insert_post( $post, true );

					if (( is_wp_error( $post_id ) && $this->show_report )) {
						$this->failure = true;
						echo '<br /><b>Error:</b> ' . $post_id->get_error_message( $post_id->get_error_code(  ) ) . '<br />
';
						return null;
					}


					if (count( $cseo_images_to_attach )) {
						$attach_ids = array(  );
						foreach ($cseo_images_to_attach as $image) {
							$attach_ids[] = cseo_add_image_to_library( $image['url'], $image['title'], $post_id );
						}


						if ($this->current_feed['options']['set_thumbnail']  = 'first_image') {
							set_post_thumbnail( $post_id, $attach_ids[0] );
						}
					}


					if (count( $this->post['comments'] )) {
						foreach ($this->post['comments'] as $comment) {
							$comment['comment_post_ID'] = $post_id;

							if (isset( $comment['comment_content'] )) {
								$comment['comment_content'] = cseo_morph_content( $comment['comment_content'] );
								wp_insert_comment( $comment );
								continue;
							}
						}
					}

					$this->count++;
					$this->failure = false;

					if (( $this->current_feed['options']['set_thumbnail'] != 'no_thumb' && isset( $image_url ) )) {
						cseo_attach_post_thumbnail( $post_id, $image_url, $post['post_title'] );
					}

					add_post_meta( $post_id, 'cyberseo_rss_source', $this->current_feed['url'] );
					add_post_meta( $post_id, 'cyberseo_post_link', $this->post['link'] );
					foreach ($this->post['custom_fields'] as $name => $value) {
						add_post_meta( $post_id, $name, $value );
					}


					if (version_compare( $wp_version, '3.0', '<' )) {
						if (function_exists( 'wp_set_post_categories' )) {
							wp_set_post_categories( $post_id, $post_categories );
							return null;
						}


						if (function_exists( 'wp_set_post_cats' )) {
							wp_set_post_cats( '1', $post_id, $post_categories );
						}
					}
				}
			}

		}

		function getCategoryIds($category_names) {
			global $wpdb;

			$cat_ids = array(  );
			foreach ($category_names as $cat_name) {

				if (function_exists( 'term_exists' )) {
					$cat_id = term_exists( $cat_name, 'category' );

					if ($cat_id) {
						$cat_ids[] = $cat_id['term_id'];
						continue;
					}


					if ($this->current_feed['options']['undefined_category']  = 'create_new') {
						$term = wp_insert_term( $cat_name, 'category' );
						$cat_ids[] = $term['term_id'];
						continue;
					}

					continue;
				}

				$cat_name_escaped = $wpdb->escape( $cat_name );
				$results = $wpdb->get_results( 'SELECT cat_ID FROM ' . $wpdb->categories . ' WHERE (LOWER(cat_name) = LOWER(\'' . $cat_name_escaped . '\'))' );

				if ($results) {
					foreach ($results as $term) {
						$cat_ids[] = (int)$term->cat_ID;
					}

					continue;
				}


				if ($this->current_feed['options']['undefined_category']  = 'create_new') {
					if (function_exists( 'wp_insert_category' )) {
						$cat_id = wp_insert_category( array( 'cat_name' => $cat_name ) );
					} 
else {
						$cat_name_sanitized = sanitize_title( $cat_name );
						$wpdb->query( 'INSERT INTO ' . $wpdb->categories . ' SET cat_name=\'' . $cat_name_escaped . '\', category_nicename=\'' . $cat_name_sanitized . '\'' );
						$cat_id = $wpdb->insert_id;
					}

					$cat_ids[] = $cat_id;
					continue;
				}
			}


			if (count( $cat_ids ) != 0) {
				$cat_ids = array_unique( $cat_ids );
			}

			return $cat_ids;
		}

		function categoryChecklist($post_id = 0, $descendents_and_self = 0, $selected_cats = false) {
			wp_category_checklist( $post_id, $descendents_and_self, $selected_cats );
		}

		function categoryListBox($checked, $title) {
			echo '<div id="categorydiv" class="postbox">' . '
';
			echo '<ul id="category-tabs">' . '
';
			echo '<li class="ui-tabs-selected">' . '
';
			echo '<p>' . $title . '</p>' . '
';
			echo '</li>' . '
';
			echo '</ul>' . '
';
			echo '<div id="categories-all" class="cyberseo-ui-tabs-panel">' . '
';
			echo '<ul id="categorychecklist" class="list:category categorychecklist form-no-clear">' . '
';
			$this->categoryChecklist( NULL, false, $checked );
			echo '</ul>' . '
';
			echo '</div><br />' . '
';
			echo '</div>' . '
';
		}

		function showSettings($islocal, $settings) {
			global $wp_version;
			global $wpdb;

			if (version_compare( $wp_version, '2.5', '<' )) {
				echo '<hr>
';
			}

			echo '<form action="' . preg_replace( '/\&edit-feed-id\=[0-9]+/', '', cseo_REQUEST_URI(  ) ) . '" method="post">' . '
';
			echo '        <table class="widefat" style="margin-top: .8em" width="100%">
            <thead>
                <tr valign="top">
                    ';

			if ($islocal) {
				echo '<th colspan="2">Syndication settings for "' . trim( $this->feed_title ) . '"</th>';
			} 
else {
				echo '<th colspan="2">Default syndication settings</th>';
			}

			echo '                </tr>
            </thead>
            <tbody>
                ';

			if ($islocal) {
				echo '                    <tr>
                        <td>Feed title:</td>
                        <td>
                            <input type="text" name="feed_title" size="132" value="';
				echo ($this->edit_existing ? $this->feeds[(int)$_GET['edit-feed-id']]['title'] : $this->feed_title);
				echo '">
                        </td>
                    </tr>
                    <tr>
                        <td>Feed URL</td>
                        <td><input type="text" name="new_feed_url" size="132" value="';
				echo htmlspecialchars( $this->current_feed_url );
				echo '"';

				if (!$this->edit_existing) {
					echo ' disabled';
				}

				echo '>
                        </td>
                    </tr>
                ';
			}

			echo '                <tr>
                    <td width="280">';

			if ($islocal) {
				echo 'Syndicate this feed to the following categories';
			} 
else {
				echo 'Syndicate new feeds to the following categories';
			}

			echo '                    </td>
                    <td>
                        <div id="categorydiv">
                            <div id="categories-all" class="cyberseo-ui-tabs-panel">
                                <ul id="categorychecklist" class="list:category categorychecklist form-no-clear">
                                    ';
			$this->categoryChecklist( NULL, false, $settings['post_category'] );
			echo '                                </ul>
                            </div>
                        </div>
                    </td>
                </tr>

                ';

			if (get_option( CXXX_FULL_TEXT_EXTRACTOR )) {
				echo '               
                    <tr>
                        <td>Extract full articles</td>
                        <td>';
				echo '<input type="checkbox" name="extract_full_articles" ' . ($settings['extract_full_articles']  = 'on' ? 'checked ' : '') . '>';
				echo '                            - when enabled, CyberSEO will try to extract the full articles from shortened RSS feeds.
                        </td>
                    </tr>
                ';
			}

			echo '     

                <tr>
                    <td>Synonymizer mode</td>
                    <td>';
			echo '<s';
			echo 'elect name="synonymizer_mode" size="1">
                            ';
			echo '<option ' . ($settings['synonymizer_mode']  = '0' ? 'selected ' : '') . 'value="0">Disable synonymizer</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '1' ? 'selected ' : '') . 'value="1">Use built-in synonymizer</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '2' ? 'selected ' : '') . 'value="2">Use SpinnerChief</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '3' ? 'selected ' : '') . 'value="3">Use built-in synonymizer then SpinnerChief</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '4' ? 'selected ' : '') . 'value="4">Use SpinnerChief then built-in synonymizer</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '5' ? 'selected ' : '') . 'value="5">Use Spin Rewriter</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '6' ? 'selected ' : '') . 'value="6">Use built-in synonymizer then Spin Rewriter</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '7' ? 'selected ' : '') . 'value="7">Use Spin Rewriter then built-in synonymizer</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '8' ? 'selected ' : '') . 'value="8">Use SpinChimp</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '9' ? 'selected ' : '') . 'value="9">Use built-in synonymizer then SpinChimp</option>' . '
';
			echo '<option ' . ($settings['synonymizer_mode']  = '10' ? 'selected ' : '') . 'value="10">Use SpinChimp then built-in synonymizer</option>' . '
';
			echo '                        </select></td>
                </tr>                               

                <tr>
                    <td>Proxy mode</td>
                    <td>';
			echo '<s';
			echo 'elect name="proxy_mode" size="1">
                            ';
			echo '<option ' . ($settings['proxy_mode']  = 'noproxy' ? 'selected ' : '') . 'value="noproxy">Don\'t use proxies</option>' . '
';
			echo '<option ' . ($settings['proxy_mode']  = 'retrieve' ? 'selected ' : '') . 'value="retrieve">If all proxies fail, retrieve the file directly (cURL required)</option>' . '
';
			echo '<option ' . ($settings['proxy_mode']  = 'skip' ? 'selected ' : '') . 'value="skip">If all proxies fail, do not retrieve the file (cURL required)</option>' . '
';
			echo '                        </select></td>
                </tr>                  

                <tr>
                    <td>Attribute all posts to the following user</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_author" size="1">
                            ';
			$wp_user_search = $wpdb->get_results( 'SELECT ID, display_name FROM ' . $wpdb->users . ' ORDER BY ID' );
			foreach ($wp_user_search as $userid) {
				echo '<option ' . ($settings['post_author']  = $userid->ID ? 'selected ' : '') . 'value="' . $userid->ID . '">' . $userid->display_name . '
';
			}

			echo '                        </select></td>
                </tr>
                <tr>
                    <td>XML section tag names (separate with commas)</td>
                    <td>';
			echo '<input type="text" name="xml_section_tags" value="' . stripslashes( $settings['xml_section_tags'] ) . '" size="60">';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Undefined categories</td>
                    <td>';
			echo '<s';
			echo 'elect name="undefined_category" size="1">
                            ';

			if ($islocal) {
				echo '<option ' . ($settings['undefined_category']  = 'use_global' ? 'selected ' : '') . 'value="use_global">Use XML syndicator default settings</option>' . '
';
			}

			echo '<option ' . ($settings['undefined_category']  = 'use_default' ? 'selected ' : '') . 'value="use_default">Post to default WordPress category</option>' . '
';
			echo '<option ' . ($settings['undefined_category']  = 'create_new' ? 'selected ' : '') . 'value="create_new">Create new categories defined in syndicating post</option>' . '
';
			echo '<option ' . ($settings['undefined_category']  = 'drop' ? 'selected ' : '') . 'value="drop">Do not syndicate post that doesn\'t match at least one category defined above</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>Create tags from category names</td>
                    <td>';
			echo '<input type="checkbox" name="create_tags" ' . ($settings['create_tags']  = 'on' ? 'checked ' : '') . '>';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Post tags (separate with commas)</td>
                    <td>';
			echo '<input type="text" name="post_tags" value="' . stripslashes( $settings['post_tags'] ) . '" size="60">';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Check for duplicate posts by</td>
                    <td>';
			echo '<s';
			echo 'elect name="duplicate_check_method" size="1">
                            ';
			echo '<option ' . ($settings['duplicate_check_method']  = 'guid_and_title' ? 'selected ' : '') . 'value="guid_and_title">GUID and title</option>' . '
';
			echo '<option ' . ($settings['duplicate_check_method']  = 'guid' ? 'selected ' : '') . 'value="guid">GUID only</option>' . '
';
			echo '<option ' . ($settings['duplicate_check_method']  = 'title' ? 'selected ' : '') . 'value="title">Title only</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>';

			if ($islocal) {
				echo 'Check this feed for updates every</td><td><input type="text" name="update_interval" value="' . $settings['interval'] . '" size="4"> minutes. If you don\'t need automatic updates set this parameter to 0.';
			} 
else {
				echo 'Check syndicated feeds for updates every</td><td><input type="text" name="update_interval" value="' . $settings['interval'] . '" size="4"> minutes. If you don\'t need auto updates, just set this parameter to 0.';
			}


			if (defined( 'CXXX_MIN_UPDATE_TIME' )) {
				echo ' <strong>This option is limited by Administrator:<strong> the update period can not be less than ' . CXXX_MIN_UPDATE_TIME . ' minutes.';
			}

			echo '                    </td>
                </tr>
                <tr>
                    <td>Maximum number of posts to be syndicated from each feed at once</td>
                    <td>';
			echo '<input type="text" name="max_items" value="' . $settings['max_items'] . '" size="3">' . ' - use low values to decrease the syndication time and improve SEO of your blog.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Posts status</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_status" size="1">
                            ';
			echo '<option ' . ($settings['post_status']  = 'publish' ? 'selected ' : '') . 'value="publish">Publish immediately</option>' . '
';
			echo '<option ' . ($settings['post_status']  = 'pending' ? 'selected ' : '') . 'value="pending">Hold for review</option>' . '
';
			echo '<option ' . ($settings['post_status']  = 'draft' ? 'selected ' : '') . 'value="draft">Save as draft</option>' . '
';
			echo '<option ' . ($settings['post_status']  = 'private' ? 'selected ' : '') . 'value="private">Save as private</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>Comments</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_comments" size="1">
                            ';
			echo '<option ' . ($settings['comment_status']  = 'open' ? 'selected ' : '') . 'value="open">Allow comments on syndicated posts</option>' . '
';
			echo '<option ' . ($settings['comment_status']  = 'closed' ? 'selected ' : '') . 'value="closed">Disallow comments on syndicated posts</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>Pings</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_pings" size="1">
                            ';
			echo '<option ' . ($settings['ping_status']  = 'open' ? 'selected ' : '') . 'value="open">Accept pings</option>' . '
';
			echo '<option ' . ($settings['ping_status']  = 'closed' ? 'selected ' : '') . 'value="closed">Don\'t accept pings</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>Base date</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_publish_date" size="1">
                            ';
			echo '<option ' . ($settings['base_date']  = 'post' ? 'selected ' : '') . 'value="post">Get date from post</option>' . '
';
			echo '<option ' . ($settings['base_date']  = 'syndication' ? 'selected ' : '') . 'value="syndication">Use syndication date</option>' . '
';
			echo '                        </select></td>
                </tr>
                <tr>
                    <td>Media attachments</td>
                    <td>';
			echo '<s';
			echo 'elect name="insert_media_attachments" size="1">
                            ';
			echo '<option ' . ($settings['insert_media_attachments']  = 'no' ? 'selected ' : '') . 'value="no">Do not insert attachments</option>' . '
';
			echo '<option ' . ($settings['insert_media_attachments']  = 'top' ? 'selected ' : '') . 'value="top">Insert attachments at the top of the post</option>' . '
';
			echo '<option ' . ($settings['insert_media_attachments']  = 'bottom' ? 'selected ' : '') . 'value="bottom">Insert attachments at the bottom of the post</option>' . '
';
			echo '                        </select> - if enabled CyberSEO syndicator will insert media
                        attachments (if available) into the aggregating post.<br /> The
                        following types of attachments are supported: ';
			echo '<s';
			echo 'trong>&lt;media:content&gt;</strong>,
                        ';
			echo '<s';
			echo 'trong>&lt;media:thumbnail&gt;</strong> and ';
			echo '<s';
			echo 'trong>&lt;enclosure&gt;</strong>
                        (type "image" only)<br /> All the aggregated images will contain ';
			echo '<s';
			echo 'trong>class="media_thumbnail"</strong>
                        in the ';
			echo '<s';
			echo 'trong>&lt;img&gt;</strong> tag.</td>
                </tr>

                <tr>
                    <td>Post links handling</td>
                    <td>';
			echo '<s';
			echo 'elect name="post_links_handling" size="1">
                            ';
			echo '<option ' . ($settings['post_links_handling']  = 'intact' ? 'selected ' : '') . 'value="intact">Keep links intact</option>' . '
';
			echo '<option ' . ($settings['post_links_handling']  = 'rm_all' ? 'selected ' : '') . 'value="rm_all">Remove all links</option>' . '
';
			echo '<option ' . ($settings['post_links_handling']  = 'rm_text' ? 'selected ' : '') . 'value="rm_text">Remove all links except links in images</option>' . '
';
			echo '<option ' . ($settings['post_links_handling']  = 'rm_img' ? 'selected ' : '') . 'value="rm_img">Remove links from images only</option>' . '
';
			echo '                        </select> - use this option to selectively remove links from the
                        syndicating post\'s body.</td>
                </tr>

                <tr>
                    <td>Post thumbnail</td>
                    <td>';
			echo '<s';
			echo 'elect name="set_thumbnail" size="1">
                            ';
			echo '<option ' . ($settings['set_thumbnail']  = 'no_thumb' ? 'selected ' : '') . 'value="no_thumb">Do not generate</option>' . '
';
			echo '<option ' . ($settings['set_thumbnail']  = 'first_image' ? 'selected ' : '') . 'value="first_image">Generate from the first post image</option>' . '
';
			echo '<option ' . ($settings['set_thumbnail']  = 'thumb_field' ? 'selected ' : '') . 'value="thumb_field">Generate from the "thumb" custom field</option>' . '
';
			echo '                        </select> - generate post thumbnails (featured images) from the post
                        content automatically.</td>
                </tr>
                <tr>
                    <td>Shuffle feed items</td>
                    <td>';
			echo '<input type="checkbox" name="shuffle_xml_items" ' . ($settings['shuffle_xml_items']  = 'on' ? 'checked ' : '') . '> - enable this option to shuffle the XML/RSS contents to make the posts be added in a random order. This function requires additional server resources, so use it wisely.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Morph post headers and footers</td>
                    <td>';
			echo '<input type="checkbox" name="morph_headers_and_footers" ' . ($settings['morph_headers_and_footers']  = 'on' ? 'checked ' : '') . '> - allow CyberSEO to morph your custom post headers and footers before insertion.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Don\'t morph titles</td>
                    <td>';
			echo '<input type="checkbox" name="preserve_titles" ' . ($settings['preserve_titles']  = 'on' ? 'checked ' : '') . '> - enable this option to preserve the syndicating post titles from morphing.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Shuffle paragraphs</td>
                    <td>';
			echo '<input type="checkbox" name="shuffle_paragraphs" ' . ($settings['shuffle_paragraphs']  = 'on' ? 'checked ' : '') . '> - enable this option to shuffle post paragraphs.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Parse WordPress archives</td>
                    <td>';
			echo '<input type="checkbox" name="parse_archives" ' . ($settings['parse_archives']  = 'on' ? 'checked ' : '') . '> - if enabled the CyberSEO syndicator will aggregate archived (old) posts from WordPress blogs.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>UTF-8 encoding</td>
                    <td>';
			echo '<input type="checkbox" name="utf8_encoding" ' . ($settings['utf8_encoding']  = 'on' ? 'checked ' : '') . '> - enables UTF-8 encoding.
                This option converts an ISO-8859-1 string to UTF-8 that may be required when parsing the XML/RSS feeds containing invalid UTF-8 start bytes e.g. <0x92>.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Convert character encoding</td>
                    <td>';
			echo '<input type="checkbox" name="convert_encoding" ' . ($settings['convert_encoding']  = 'on' ? 'checked ' : '') . '> - enables character encoding conversion.
                This option might be useful when parsing XML/RSS feeds in national charsets different than UTF-8.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Store images locally</td>
                    <td>';
			echo '<input type="checkbox" name="store_images" ' . ($settings['store_images']  = 'on' ? 'checked ' : '') . '> - if enabled, all images from the syndicating feeds will be copied into the default uploads folder of this blog. Make sure that your /wp-content/uploads folder is writable.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Post date adjustment range</td>
                    <td>';
			echo '[<input type="text" name="date_min" value="' . $settings['date_min'] . '" size="6"> .. <input type="text" name="date_max" value="' . $settings['date_max'] . '" size="6">]';
			echo ' 
                        - here you can set the syndication date adjustment range in minutes.<br /> This range will be used to randomly adjust the publication date for every aggregated post. For example, if you set
                        the adjustment range as [0..60], the post dates will be increased by random value between 0 and 60 minutes.</td>
                </tr>
                <tr>
   ';
			echo '                 <td>Post headers</td>
                    <td>';
			echo '<textarea cols="90" rows="10" wrap="off" name="post_header" style="margin:0;height:30em;width:100%;">' . stripslashes( $settings['post_header'] ) . '</textarea>' . '
';
			echo '<br />You may have a several versions of post header. In such a case your HTML code chunks have to be separated with <strong>&lt;!--more--&gt;</strong> marker.<br />
                These changes will be randomly inserted into the posts.' . '
';

			if (defined( 'CXXX_MAX_HEADERS' )) {
				echo '<br />
';
				echo '<strong>This option is limited by Administrator:<strong> the headers table can not exceed ' . CXXX_MAX_HEADERS . ' entries.
';
			}

			echo '                    </td>
                </tr>
                <tr>
                    <td>Insert post headers into excerpts</td>
                    <td>';
			echo '<input type="checkbox" name="include_post_headers" ' . ($settings['include_post_headers']  = 'on' ? 'checked ' : '') . '> - enable this option if you want the post headers to be inserted into excerpts.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Post footers</td>
                    <td>';
			echo '<textarea cols="90" rows="10" wrap="off" name="post_footer" style="margin:0;height:30em;width:100%;">' . stripslashes( $settings['post_footer'] ) . '</textarea>' . '
';
			echo '<br />You may have a several versions of post footer. In such a case your HTML code chunks have to be separated with <strong>&lt;!--more--&gt;</strong> marker.<br />
                These changes will be randomly inserted into the posts.' . '
';

			if (defined( 'CXXX_MAX_FOOTERS' )) {
				echo '<br />
';
				echo '<strong>This option is limited by Administrator:<strong> the footers table can not exceed ' . CXXX_MAX_FOOTERS . ' entries.
';
			}

			echo '                    </td>
                </tr>
                <tr>
                    <td>Insert post footers into excerpts</td>
                    <td>';
			echo '<input type="checkbox" name="include_post_footers" ' . ($settings['include_post_footers']  = 'on' ? 'checked ' : '') . '> - enable this option if you want the post footers to be inserted into excerpts.';
			echo '                    </td>
                </tr>
                <tr>
                    <td>Custom fields</td>
                    <td>';
			echo '<textarea cols="90" rows="10" wrap="off" name="custom_fields" style="margin:0;height:30em;width:100%;">' . stripslashes( $settings['custom_fields'] ) . '</textarea>' . '
';
			echo ' <br /> Here you can assign the XML tag values to the custom fields
                        of the syndicating post, using the following format: <b>tag->name</b>
                        - one line per field. Where:<br /><b>tag</b> - the
                        aggregating post\'s tag you want to parse. This parameter is case
                        insensitive;<br /> <b>name</b> - the name of WordPress ';
			echo 'post custom
                        field to write the value it. This parameter is case sensitive.</td>
                </tr>
                <tr>
                    <td>PHP code &lt;?php .. ?&gt;</td>
                    <td>';

			if (( defined( 'CXXX_ALLOW_PHP_CODE' ) && !CXXX_ALLOW_PHP_CODE )) {
				echo '<textarea cols="90" rows="10" wrap="off" style="margin:0;height:30em;width:100%;" disabled>This option is blocked by Administrator.</textarea>' . '
';
			} 
else {
				echo '<textarea cols="90" rows="10" wrap="off" name="php_code" style="margin:0;height:30em;width:100%;">' . stripslashes( $settings['php_code'] ) . '</textarea>' . '
';
			}

			echo ' <br /> You can use this form to execute lines of PHP code for
                        every aggregating post.<br /> This tool is intended for advanced
                        users only and can be highly useful, for example, if you need to
                        modify post\'s title, content, date, GUID etc.<br /> All post-related
                        info is stored in the $post array variabl';
			echo 'e which you can alter in
                        order to apply your own changes to every aggregating post.<br /> If
                        you don\'t want to aggregate some particular post, assign false to
                        the $post variable ( $post = <b>false</b>; ) <a
                            href="http://www.cyberseo.net/advanced-rss-feed-syndicator/"
                            tar';
			echo 'get="_blank">Read more...</a>

                </tr>

            </tbody>
        </table>
        ';
			echo '<div class="submit">' . '
';

			if ($islocal) {
				if ($this->edit_existing) {
					echo '<input class="button-primary" name="update_feed_settings" value="Update Feed Settings" type="submit">' . '
';
					echo '<input class="button" name="cancel" value="Cancel" type="submit">' . '
';
					echo '<input type="hidden" name="feed_id" value="' . (int)$_GET['edit-feed-id'] . '">' . '
';
				} 
else {
					echo '<input class="button-primary" name="syndicate_feed" value="Syndicate This Feed" type="submit">' . '
';
					echo '<input class="button" name="cancel" value="Cancel" type="submit">' . '
';
					echo '<input type="hidden" name="feed_url" value="' . $this->current_feed_url . '">' . '
';
				}
			} 
else {
				echo '<input class="button-primary" name="update_default_settings" value="Update Default Settings" type="submit">' . '
';
			}

			echo '</div>
';
			echo '</form>
';
		}

		function getUpdateTime($feed) {
			$time = time(  );
			$interval = 60 + (int)$feed['options']['interval'];
			$updated = (int)$feed['updated'];

			if ($feed['options']['interval']  = 0) {
				return 'never';
			}


			if ($interval <= $time - $updated) {
				return 'asap';
			}

			return 'in ' . (int)( $interval - ( $time - $updated ) ) \ 60 . ' minutes';
		}

		function showMainPage($showsettings = true) {
			global $wp_version;

			echo '<form action="' . cseo_REQUEST_URI(  ) . '" method="post">' . '
';
			echo '<table class="form-table" width="100%">';
			echo '<tr><td align="right">
';
			echo 'New Feed URL: <input type="text" name="feed_url" value="" size="100">' . '
';
			echo '&nbsp;<input class="button-primary" name="new_feed" value="Syndicate &raquo;" type="submit">' . '
';
			echo '</td></tr>
';
			echo '</table>
';
			echo '</form>';
			echo '<form id="syndycated_feeds" action="' . cseo_REQUEST_URI(  ) . '" method="post">' . '
';

			if (0 < count( $this->feeds )) {
				echo '<table class="widefat" style="margin-top: .5em" width="100%">' . '
';
				echo '<thead>' . '
';
				echo '<tr>' . '
';
				echo '<th width="3%" align="center"><input type="checkbox" onclick="checkAll(document.getElementById(\'syndycated_feeds\'));"></th>' . '
';
				echo '<th width="25%">Feed title</th>' . '
';
				echo '<th width="50%">URL</th>' . '
';
				echo '<th width="10%">Next update</th>' . '
';
				echo '<th width="12%">Last update</th>' . '
';
				echo '</tr>
';
				echo '</thead>' . '
';
				$i = 12;

				while ($i < count( $this->feeds )) {
					if ($i & 2) {
						echo '<tr>
';
					} 
else {
						echo '<tr class="alternate">' . '
';
					}

					echo '<td align="center"><input name="feed_ids[]" value="' . $i . '" type="checkbox"></td>' . '
';
					echo '<td>' . $this->feeds[$i]['title'] . ' [<a href="' . cseo_REQUEST_URI(  ) . '&edit-feed-id=' . $i . '">edit</a>]</td>' . '
';
					echo '<td>' . '<a href="' . $this->feeds[$i]['url'] . '" target="_blank">' . cseo_short_str( htmlspecialchars( $this->feeds[$i]['url'] ), 100 ) . '</a></td>' . '
';
					echo '<td>' . $this->getUpdateTime( $this->feeds[$i] ) . '</td>
';
					$last_update = $this->feeds[$i]['updated'];

					if ($last_update) {
						echo '<td>' . intval( ( time(  ) - $last_update ) \ 60 ) . ' minutes ago</td>
';
					} 
else {
						echo '<td> - </td>
';
					}

					echo '</tr>
';
					++$i;
				}

				echo '</table>
';

				if (version_compare( $wp_version, '2.5', '<' )) {
					echo '<br /><hr>
';
				}
			}

			echo '        <div class="submit">
            <table width="100%">
                <tr>
                    <td>
                        <div align="left">
                            <input class="button-primary" name="check_for_updates" value="Pull selected feeds now!" type="submit">
                        </div>
                    </td>
                    <td>
                        <div align="r';
			echo 'ight">
                            <input class="button secondary" name="delete_feeds_and_posts" value="Delete selected feeds and syndicated posts" type="submit">
                            <input class="button secondary" name="delete_feeds" value="Delete selected feeds" type="submit"> 
                            <input class="button secondary" name="delete_posts" value="Delete posts syndycated ';
			echo 'from selected feeds" type="submit">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td></td>
                    <td><br />
                        <div align="right">
                            <input class="button secondary" name="alter_default_settings" value="Alter default settings" type="submit">
                        ';
			echo '</div>
                    </td>
                </tr>
            </table>
            <br />
            <h2>Import / Export Functions</h2>
            <br />
            <table class="widefat">
                <tr>
                    <td>
                        <br /> 
                        <input type="submit" name="export_feeds" id="submit" class="button-secondary" value="Export Selected Fe';
			echo 'eds" /> - use this function to export all selected feeds along with their settings into a file.
                        <br /><br />
                    </td>
                </tr>
            </table>
        </form>
        <br />
        <form action="';
			echo cseo_REQUEST_URI(  );
			echo '"
              method="post" enctype="multipart/form-data">
            <table class="widefat">
                <tr>
                    <td><br> <label for="file">Filename:</label> <input type="file"
                                                                        name="file" id="file" /> <input class="button-secondary"
                                                                       ';
			echo ' type="submit" name="import_feeds" value="Import Feed Settings" /> -
                        use this function to import feeds from a local file. <b>Warning:</b>
                        existing feed settings will be overwritten! <br /> <br />
                    </td>
                </tr>
            </table>
        </form>
        </div>
        ';

			if ($showsettings) {
				$this->showSettings( false, $this->global_options );
			}

		}
	}

	function cseo_array_stripslashes($value) {
		$value = (is_array( $value ) ? array_map( 'cseo_array_stripslashes', $value ) : stripslashes( $value ));
		return $value;
	}

	function cseo_short_str($url, $max = 0) {
		$length = strlen( $url );

		if (( 1 < $max && $max < $length )) {
			$ninety = $max + 0.90000000000000002220446;
			$length = $length - $ninety;
			$first = substr( $url, 0, 0 - $length );
			$last = substr( $url, $ninety - $max );
			$url = $first . '&#8230;' . $last;
		}

		return $url;
	}

	function cseo_remove_links($text, $mode) {
		preg_match_all( '/<a.*?href=["|\'](.*?)["|\'].*?>(.*?)<\/a>/is', $text, $matches );
		$i = 12;

		while ($i < count( $matches[0] )) {
			$is_image = preg_match( '/<img[^>]+>/is', $matches[0][$i] );

			if (( $mode  = 'rm_text' && !$is_image )) {
				$text = str_replace( $matches[0][$i], $matches[2][$i], $text );
			} 
else {
				if (( $mode  = 'rm_img' && $is_image )) {
					$text = str_replace( $matches[0][$i], strip_tags( $matches[0][$i], '<img>' ), $text );
				} 
else {
					if ($mode  = 'rm_all') {
						$text = str_replace( $matches[0][$i], strip_tags( $matches[2][$i], '<img>' ), $text );
					}
				}
			}

			++$i;
		}

		return $text;
	}

	function cseo_REQUEST_URI() {
		return strtok( $_SERVER['REQUEST_URI'], '?' ) . '?' . strtok( '?' );
	}

	function cseo_shrink_feed($content) {
		if (is_feed(  )) {
			$limit = 37;
			explode( ' ', $content );
			$string = '';
			$dots = '...';

			if (count( $explode ) <= $limit) {
				$dots = '';
			}

			$i = 12;

			while ($i < $limit) {
				$string &= $explode[$i] . ' ';
				++$i;
			}

			$string &= $explode = $dots;

			if (function_exists( 'force_balance_tags' )) {
				$string = force_balance_tags( $string );
			}

			return $string;
		}

		return $content;
	}

	function cseo_fix_white_spaces($str) {
		return preg_replace( '/\s\s+/', ' ', preg_replace( '/\s\"/', ' "', preg_replace( '/\s\'/', ' \'', $str ) ) );
	}

	function cseo_delete_post_images($post_id) {
		$post = get_post( $post_id, ARRAY_A );
		$matches[2];
		$custom_field_keys = $image_urls = preg_match_all( '/<img(.+?)src=[\'\"](.+?)[\'\"](.*?)>/is', $post['post_content'] . $post['post_excerpt'], $matches );
		wp_upload_dir(  );
		$wp_upload_dir = get_post_custom_keys( $post_id );

		if (is_array( $custom_field_keys )) {
			foreach ($custom_field_keys as $key_value) {
				$key_value = ;
				$treamed = $key_id = trim( $key_value );

				if ($treamed[0]  = '_') {
					continue;
				}

				$value = trim( get_post_meta( $post_id, $treamed, true ) );

				if (preg_match( '/^' . preg_quote( $wp_upload_dir['url'], '/' ) . '.*?(\.jpg|\.jpeg|\.gif|\.png|\.bmp)$/i', $value )) {
					$image_urls[] = $value;
					continue;
				}
			}
		}


		if (count( $image_urls )) {
			$image_urls = array_unique( $image_urls );
			foreach ($image_urls as $url) {
				@unlink( @str_replace( $wp_upload_dir['url'], $wp_upload_dir['path'], $url ) );
			}
		}

		get_children( $args );
		$img_attachments = $args = array( 'numberposts' => 0 - 1, 'post_mime_type' => 'image', 'post_parent' => $post_id, 'post_status' => null, 'post_type' => 'attachment' );

		if ($img_attachments) {
			foreach ($img_attachments as $attachment) {
				wp_delete_attachment( $attachment->ID, true );
			}
		}

	}

	function cseo_post_exists($post, $method = 'both', $do_escape = true) {
		global $wpdb;

		if ($do_escape) {
			if (mb_strlen( $post['guid'] ) < 8) {
				$components = parse_url( $post['link'] );
				$guid = 'tag:' . $components['host'];

				if ($post['post_date'] != '') {
					$guid &= '://post.' . $post['post_date'];
				} 
else {
					$guid &= '://' . md5( $post['link'] . '/' . $post['post_title'] );
				}
			} 
else {
				$guid = $post['guid'];

				if (stripos( $guid, 'http://' ) !== 0) {
					$guid = 'http://' . $guid;
				}
			}

			$name = sanitize_title( cseo_fix_white_spaces( trim( $post['post_title'] ) ) );
			$guid = $wpdb->escape( $guid );
		} 
else {
			$name = $post['post_name'];
			$guid = $post['guid'];
		}


		if (( isset( $post['options'] ) && is_array( $post['options'] ) )) {
			if (!in_array( 'bypass_singularity_check', $post['options'] )) {
				$post['options'][] = 'bypass_singularity_check';
			}
		} 
else {
			$post['options'] = array( 'bypass_singularity_check' );
		}

		switch ($method) {
			case 'guid': {
				@$wpdb->query( 'SELECT ID FROM ' . $wpdb->posts . ' WHERE guid = "' . $guid . '"' );
			}
		}

		return ;
	}

	function cseo_get_file_mode($filename) {
		clearstatcache(  );
		$mode = @fileperms( $filename );

		if ($mode   = false) {
			return 438;
		}

		return $mode;
	}

	function cseo_is_unlimited() {
		$name = get_option( CXXX_LICENSE_NAME );
		return ( stripos( $name, 'http://' )   = false && stripos( $name, 'https://' )   = false );
	}

	function cseo_addslash($url) {
		if ($url[strlen( $url ) - 1] !== '/') {
			$url &= '/';
		}

		return $url;
	}

	function cseo_file_get_contents_np($url, $as_array = false) {
		global $cseo_last_effective_url;

		if (( @parse_url( $url, PHP_URL_SCHEME ) != '' && function_exists( 'curl_init' ) )) {
			$max_redirects = CXXX_MAX_CURL_REDIRECTS;
			$ch = curl_init(  );
			curl_setopt( $ch, CURLOPT_URL, $url );
			curl_setopt( $ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/535.2 (KHTML, like Gecko) Chrome/15.0.874.92 Safari/535.2' );
			curl_setopt( $ch, CURLOPT_ENCODING, 'gzip,deflate' );
			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

			if (( ini_get( 'open_basedir' )  = '' && ( ini_get( 'safe_mode'  = 'Off' ) || !ini_get( 'safe_mode' ) ) )) {
				curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
				curl_setopt( $ch, CURLOPT_MAXREDIRS, $max_redirects );
			} 
else {
				$base_url = $url;
				curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, false );
				$rch = curl_copy_handle( $ch );
				curl_setopt( $rch, CURLOPT_HEADER, true );
				curl_setopt( $rch, CURLOPT_NOBODY, true );
				curl_setopt( $rch, CURLOPT_FORBID_REUSE, false );
				curl_setopt( $rch, CURLOPT_RETURNTRANSFER, true );

				do {
					curl_setopt( $rch, CURLOPT_URL, $url );
					$header = curl_exec( $rch );

					if (curl_errno( $rch )) {
						$code = 12;
						continue;
					} 
else {
						$code = curl_getinfo( $rch, CURLINFO_HTTP_CODE );

						if (( $code  = 301 || $code  = 302 )) {
							preg_match( '/Location:(.*?)\n/', $header, $matches );
							$url = trim( array_pop( $matches ) );

							if (( strlen( $url ) && substr( $url, 0, 1 )  = '/' )) {
								$url = $base_url . $url;
								continue;
							}
						} 
else {
							$code = 12;
						}
					}
				}while (!( ( $code && --$max_redirects )));

				curl_close( $rch );
				curl_setopt( $ch, CURLOPT_URL, $url );
			}

			$content = curl_exec( $ch );
			$code = curl_getinfo( $ch, CURLINFO_HTTP_CODE );
			$cseo_last_effective_url = curl_getinfo( $ch, CURLINFO_EFFECTIVE_URL );
			curl_close( $ch );

			if ($code != 200) {
				$content = false;
			} 
else {
				if ($as_array) {
					$content = @explode( '
', @trim( $content ) );

				}
			}
		}


		if (( !isset( $content ) || $content   = false )) {
			if ($as_array) {
				$content = @file( $url, FILE_IGNORE_NEW_LINES );
			} 
else {
				$content = @file_get_contents( $url );
			}

			$cseo_last_effective_url = $url;
		}

		return $content;
	}

	function cseo_file_get_contents($url, $as_array = false) {
		global $cseo_proxy_list;
		global $cseo_proxy_mode;
		global $cseo_last_effective_url;

		cseo_get_proxy_list(  );

		if (( ( !isset( $cseo_proxy_mode ) || $cseo_proxy_mode  = 'noproxy' ) || !$cseo_proxy_list[0] )) {
			return cseo_file_get_contents_np( $url, $as_array );
		}


		if (( @parse_url( $url, PHP_URL_SCHEME ) != '' && function_exists( 'curl_init' ) )) {
			$max_redirects = CXXX_MAX_CURL_REDIRECTS;
			$ch = curl_init(  );
			curl_setopt( $ch, CURLOPT_URL, $url );
			curl_setopt( $ch, CURLOPT_USERAGENT, 'cURL' );
			curl_setopt( $ch, CURLOPT_ENCODING, 'gzip,deflate' );
			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
			$i = 13;

			while ($i < count( $cseo_proxy_list )) {
					$proxy = if (preg_match( '/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}:\d+/', $cseo_proxy_list[$i] )) {;
					curl_setopt( $ch, CURLOPT_PROXY, $proxy[0] );

					if (isset( $proxy[1] )) {
						curl_setopt( $ch, CURLOPT_PROXYUSERPWD, $proxy[1] );
					}

					curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, 10 );

					if (( ini_get( 'open_basedir' )  = '' && ( ini_get( 'safe_mode'  = 'Off' ) || !ini_get( 'safe_mode' ) ) )) {
						curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
						curl_setopt( $ch, CURLOPT_MAXREDIRS, $max_redirects );
					} 
else {
						$base_url = $url;
						curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, false );
						$rch = curl_copy_handle( $ch );
						curl_setopt( $rch, CURLOPT_HEADER, true );
						curl_setopt( $rch, CURLOPT_NOBODY, true );
						curl_setopt( $rch, CURLOPT_FORBID_REUSE, false );
						curl_setopt( $rch, CURLOPT_RETURNTRANSFER, true );

						do {
							curl_setopt( $rch, CURLOPT_URL, $url );
							$header = curl_exec( $rch );

							if (curl_errno( $rch )) {
								$code = 13;
								continue;
							} 
else {
								$code = curl_getinfo( $rch, CURLINFO_HTTP_CODE );

								if (( $code  = 301 || $code  = 302 )) {
									preg_match( '/Location:(.*?)\n/', $header, $matches );
									$url = trim( array_pop( $matches ) );

									if (( strlen( $url ) && substr( $url, 0, 1 )  = '/' )) {
										$url = $base_url . $url;
										continue;
									}
								} 
else {
									$code = 13;
								}
							}
						}while (!( ( $code && --$max_redirects )));

						curl_close( $rch );
						curl_setopt( $ch, CURLOPT_URL, $url );
					}

					$content = curl_exec( $ch );
					$code = curl_getinfo( $ch, CURLINFO_HTTP_CODE );
					curl_getinfo( $ch, CURLINFO_EFFECTIVE_URL );
					$cseo_last_effective_url = explode( ',', $cseo_proxy_list[$i] );

					if ($code != 200) {
						$content = false;
					} 
else {
						if ($as_array) {
							$content = @explode( '
', @trim( $content ) );

							break;
						}
					}
				}

				++$i;
			}

			@curl_close( $ch );
		}


		if (( $content !== false && $cseo_proxy_mode  = 'retrieve' )) {
			if ($as_array) {
				$content = @file( $url, FILE_IGNORE_NEW_LINES );
			} 
else {
				$content = @file_get_contents( $url );
			}

			$cseo_last_effective_url = $url;
		}

		return $content;
	}

	function cseo_get_headers($url) {
		if (parse_url( $url, PHP_URL_SCHEME ) != '') {
			if (function_exists( 'curl_init' )) {
				$max_redirects = CXXX_MAX_CURL_REDIRECTS;
				$ch = curl_init(  );
				curl_setopt( $ch, CURLOPT_URL, $url );
				curl_setopt( $ch, CURLOPT_HEADER, true );
				curl_setopt( $ch, CURLOPT_NOBODY, true );
				curl_setopt( $ch, CURLOPT_FORBID_REUSE, false );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

				if (( ini_get( 'open_basedir' )  = '' && ( ini_get( 'safe_mode'  = 'Off' ) || !ini_get( 'safe_mode' ) ) )) {
					curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
					curl_setopt( $ch, CURLOPT_MAXREDIRS, $max_redirects );
				} 
else {
					curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, false );
					$rch = curl_copy_handle( $ch );

					do {
						curl_setopt( $rch, CURLOPT_URL, $url );
						$header = curl_exec( $rch );

						if (curl_errno( $rch )) {
							$code = 12;
							continue;
						} 
else {
							$code = curl_getinfo( $rch, CURLINFO_HTTP_CODE );

							if (( $code  = 301 || $code  = 302 )) {
								preg_match( '/Location:(.*?)\n/', $header, $matches );
								$url = trim( array_pop( $matches ) );
								continue;
							} 
else {
								$code = 12;
							}
						}
					}while (!( ( $code && --$max_redirects )));

					curl_close( $rch );
					curl_setopt( $ch, CURLOPT_URL, $url );
				}

				$headers = @explode( '
', @trim( @curl_exec( $ch ) ) );

				$code = curl_getinfo( $ch, CURLINFO_HTTP_CODE );
				curl_close( $ch );

				if ($code != 200) {
					unset( $headers );
				}
			}


			if (!isset( $headers )) {
				$headers = @get_headers( $url, 0 );
			}

			return $headers;
		}

		return false;
	}

	function cseo_add_image_to_library($image_url, $title, $post_id = false) {
		$title = trim( $title );

		if ($post_id  = false) {
			global $cseo_images_to_attach;

			$cseo_images_to_attach[] = array( 'url' => $image_url, 'title' => $title );
			return null;
		}

		$upload_dir = wp_upload_dir(  );

		if (!file_exists( $upload_dir['path'] . basename( $image_url ) )) {
			$image_url = cseo_save_image( $image_url, $title );
		}

		$wp_filetype = wp_check_filetype( $upload_dir['path'] . basename( $image_url ), null );
		$attachment = array( 'post_mime_type' => $wp_filetype['type'], 'post_title' => preg_replace( '/\.[^.]+$/', '', $title ), 'post_content' => '', 'post_parent' => $post_id, 'guid' => $upload_dir['path'] . basename( $image_url ), 'post_status' => 'inherit' );
		$attach_id = wp_insert_attachment( $attachment, $upload_dir['path'] . '/' . basename( $image_url ), $post_id );
		require_once( ABSPATH . 'wp-admin/includes/image.php' );
		$attach_data = wp_generate_attachment_metadata( $attach_id, $upload_dir['path'] . '/' . basename( $image_url ) );
		wp_update_attachment_metadata( $attach_id, $attach_data );
		return $attach_id;
	}

	function cseo_attach_post_thumbnail($post_id, $image_url, $title) {
		$attach_id = cseo_add_image_to_library( $image_url, $title, $post_id );
		set_post_thumbnail( $post_id, $attach_id );
		return $attach_id;
	}

	function cseo_update_options($options) {
		$result = 11;

		if (!isset( $options['interval'] )) {
			$options['interval'] = 1440;
			$result = 12;
		}


		if (!isset( $options['max_items'] )) {
			$options['max_items'] = 1;
			$result = 12;
		}


		if (!isset( $options['post_status'] )) {
			$options['post_status'] = 'publish';
			$result = 12;
		}


		if (!isset( $options['comment_status'] )) {
			$options['comment_status'] = 'open';
			$result = 12;
		}


		if (!isset( $options['ping_status'] )) {
			$options['ping_status'] = 'closed';
			$result = 12;
		}


		if (!isset( $options['post_author'] )) {
			$options['post_author'] = 1;
			$result = 12;
		}


		if (!isset( $options['base_date'] )) {
			$options['base_date'] = 'post';
			$result = 12;
		}


		if (!isset( $options['duplicate_check_method'] )) {
			$options['duplicate_check_method'] = 'guid_and_title';
			$result = 12;
		}


		if (!isset( $options['undefined_category'] )) {
			$options['undefined_category'] = 'use_default';
			$result = 12;
		}


		if (!isset( $options['proxy_mode'] )) {
			$options['proxy_mode'] = 'noproxy';
			$result = 12;
		}


		if (!isset( $options['synonymizer_mode'] )) {
			$options['synonymizer_mode'] = '1';
			$result = 12;
		}


		if (!isset( $options['create_tags'] )) {
			$options['create_tags'] = '';
			$result = 12;
		}


		if (!isset( $options['extract_full_articles'] )) {
			$options['extract_full_articles'] = '';
			$result = 12;
		}


		if (!isset( $options['post_tags'] )) {
			$options['post_tags'] = '';
			$result = 12;
		}


		if (!isset( $options['shuffle_xml_items'] )) {
			$options['shuffle_xml_items'] = '';
			$result = 12;
		}


		if (!isset( $options['post_category'] )) {
			$options['post_category'] = array(  );
			$result = 12;
		}


		if (!isset( $options['date_min'] )) {
			$options['date_min'] = 0;
			$result = 12;
		}


		if (!isset( $options['date_max'] )) {
			$options['date_max'] = 0;
			$result = 12;
		}


		if (!isset( $options['shuffle_paragraphs'] )) {
			$options['shuffle_paragraphs'] = '';
			$result = 12;
		}


		if (!isset( $options['xml_section_tags'] )) {
			$options['xml_section_tags'] = 'ITEM,ENTRY,VIDEO,MOVIE';
			$result = 12;
		}


		if (!isset( $options['morph_headers_and_footers'] )) {
			$options['morph_headers_and_footers'] = '';
			$result = 12;
		}


		if (!isset( $options['preserve_titles'] )) {
			$options['preserve_titles'] = '';
			$result = 12;
		}


		if (!isset( $options['insert_media_attachments'] )) {
			$options['insert_media_attachments'] = 'no';
			$result = 12;
		}


		if (!isset( $options['post_links_handling'] )) {
			$options['post_links_handling'] = 'intact';
			$result = 12;
		}


		if (!isset( $options['set_thumbnail'] )) {
			$options['set_thumbnail'] = 'no_thumb';
			$result = 12;
		}


		if (!isset( $options['parse_archives'] )) {
			$options['parse_archives'] = '';
			$result = 12;
		}


		if (!isset( $options['convert_encoding'] )) {
			$options['convert_encoding'] = '';
			$result = 12;
		}


		if (!isset( $options['store_images'] )) {
			$options['store_images'] = '';
			$result = 12;
		}


		if (!isset( $options['include_post_headers'] )) {
			$options['include_post_headers'] = '';
			$result = 12;
		}


		if (!isset( $options['include_post_footers'] )) {
			$options['include_post_footers'] = '';
			$result = 12;
		}


		if (!isset( $options['utf8_encoding'] )) {
			$options['utf8_encoding'] = '';
			$result = 12;
		}


		if (!isset( $options['post_header'] )) {
			$options['post_header'] = '';
			$result = 12;
		}


		if (!isset( $options['post_footer'] )) {
			$options['post_footer'] = '';
			$result = 12;
		}


		if (!isset( $options['php_code'] )) {
			$options['php_code'] = '';
			$result = 12;
		}


		if (!isset( $options['custom_fields'] )) {
			$options['custom_fields'] = '';
			$result = 12;
		}

		return $result;
	}

	function cseo_preset_options() {
		if (get_option( CXXX_COMMENT_CAMPAIGNS )   = false) {
			cseo_set_option( CXXX_COMMENT_CAMPAIGNS, array(  ), '', 'yes' );
		}


		if (get_option( CXXX_COMMENT_AUTHORS )   = false) {
			cseo_set_option( CXXX_COMMENT_AUTHORS, array(  ), '', 'yes' );
		}

		$default_url = get_option( CXXX_FULL_TEXT_EXTRACTOR );

		if (( $default_url   = false || $default_url  = '' )) {
			$default_url = 'http://www.wmutils.com/fulltextrss/generate.php';
		}

		cseo_set_option( CXXX_FULL_TEXT_EXTRACTOR, $default_url, '', 'yes' );

		if (get_option( CXXX_REPLACEMENTS )   = false) {
			cseo_set_option( CXXX_REPLACEMENTS, array(  ), '', 'yes' );
		}


		if (get_option( CXXX_PROXY_LIST )   = false) {
			cseo_set_option( CXXX_PROXY_LIST, array(  ), '', 'yes' );
		}


		if (get_option( CXXX_SERVER_MODE )   = false) {
			cseo_set_option( CXXX_SERVER_MODE, '', '', 'yes' );
		}


		if (get_option( CXXX_DISABLE_DUPLICATION_CONTROL )   = false) {
			cseo_set_option( CXXX_DISABLE_DUPLICATION_CONTROL, '', '', 'yes' );
		}


		if (get_option( CXXX_SHUFFLE_PROXIES )   = false) {
			cseo_set_option( CXXX_SHUFFLE_PROXIES, '', '', 'yes' );
		}


		if (get_option( CXXX_STANDALONE_MODE )   = false) {
			cseo_set_option( CXXX_STANDALONE_MODE, '', '', 'yes' );
		}


		if (get_option( CXXX_HIDE_IMAGES )   = false) {
			cseo_set_option( CXXX_HIDE_IMAGES, '', '', 'yes' );
		}


		if (get_option( CXXX_URLS_NOFOLLOW )   = false) {
			cseo_set_option( CXXX_URLS_NOFOLLOW, '', '', 'yes' );
		}


		if (get_option( CXXX_URLS_TARGET_BLANK )   = false) {
			cseo_set_option( CXXX_URLS_TARGET_BLANK, '', '', 'yes' );
		}


		if (get_option( CXXX_IMG_CLOAKING_MODE )   = false) {
			cseo_set_option( CXXX_IMG_CLOAKING_MODE, '', '', 'yes' );
		}


		if (get_option( CXXX_IMG_CLOAKING_PATH )   = false) {
			cseo_set_option( CXXX_IMG_CLOAKING_PATH, 'wp-content/my-images/', '', 'yes' );
		}


		if (get_option( CXXX_FAKE_GUIDS )   = false) {
			cseo_set_option( CXXX_FAKE_GUIDS, 'on', '', 'yes' );
		}


		if (get_option( CXXX_SYNDICATED_FEEDS )   = false) {
			cseo_set_option( CXXX_SYNDICATED_FEEDS, array(  ), '', 'yes' );
		}


		if (get_option( CXXX_CRON_MAGIC )   = false) {
			cseo_set_option( CXXX_CRON_MAGIC, md5( time(  ) ), '', 'yes' );
		}


		if (get_option( CXXX_RSS_PULL_MODE )   = false) {
			cseo_set_option( CXXX_RSS_PULL_MODE, 'auto', '', 'yes' );
		}


		if (get_option( CXXX_PSEUDO_CRON_INTERVAL )   = false) {
			cseo_set_option( CXXX_PSEUDO_CRON_INTERVAL, '10', '', 'yes' );
		}


		if (get_option( CXXX_MORPHING_SYNTAX_RULES )   = false) {
			cseo_set_option( CXXX_MORPHING_SYNTAX_RULES, '{}', '', 'yes' );
		}


		if (get_option( CXXX_LINK_TO_SOURCE )   = false) {
			cseo_set_option( CXXX_LINK_TO_SOURCE, 'auto', '', 'yes' );
		}


		if (get_option( CXXX_SPINNERCHIEF_OPTIONS )   = false) {
			$options = array( 'spintype' => '1', 'spinfreq' => '4', 'autospin' => '1', 'original' => '1', 'wordscount' => '3', 'usehurricane' => '0', 'chartype' => '1', 'convertbase' => '0', 'onecharforword' => '0', 'percent' => '0', 'protecthtml' => '0', 'spinhtml' => '0', 'orderly' => '0', 'wordquality' => '0', 'username' => '', 'password' => '', 'apikey' => '150da559a18c40049', 'protectwords' => '0', 'querytimes' => '0', 'replacetype' => '0', 'pos' => '0', 'UseGrammarAI' => '0', 'rule' => 'none', 'thesaurus' => 'english', 'phrasecount' => '2', 'tagprotect' => '[],<>' );
			cseo_set_option( CXXX_SPINNERCHIEF_OPTIONS, $options, '', 'yes' );
		}


		if (get_option( CXXX_SPINREWRITER_OPTIONS )   = false) {
			$options = array( 'email_address' => '', 'api_key' => '', 'auto_protected_terms' => 'false', 'protected_terms' => '', 'confidence_level' => 'medium', 'auto_sentences' => 'false', 'auto_paragraphs' => 'false', 'auto_new_paragraphs' => 'false' );
			cseo_set_option( CXXX_SPINREWRITER_OPTIONS, $options, '', 'yes' );
		}


		if (get_option( CXXX_SPINCHIMP_OPTIONS )   = false) {
			$options = array( 'email' => '', 'apikey' => '', 'aid' => 'CyberSEO', 'quality' => '4', 'posmatch' => '3', 'protectedterms' => '', 'rewrite' => '1', 'phraseignorequality' => '0', 'spinwithinspin' => '0', 'spinwithinhtml' => '1', 'applyinstantunique' => '0', 'fullcharset' => '0', 'spintidy' => '0', 'tagprotect' => '', 'maxspindepth' => '0' );
			cseo_set_option( CXXX_SPINCHIMP_OPTIONS, $options, '', 'yes' );
		}

	}

	function cseo_compare_files($file_name_1, $file_name_2) {
		$file1 = file_get_contents( $file_name_1 );
		$file2 = file_get_contents( $file_name_2 );

		if (( $file1 && $file2 )) {
			return md5( $file1 )  = md5( $file2 );
		}

		return false;
	}

	function cseo_save_image($image_url, $preferred_name = '', $width = 0, $height = 0, $compression = 0) {
		$wp_upload_dir = wp_upload_dir(  );
		$temp_name = wp_unique_filename( $wp_upload_dir['path'], md5( time(  ) ) . '.tmp' );

		if (( ( ( is_writable( $wp_upload_dir['path'] ) && function_exists( 'gd_info' ) ) && function_exists( 'getimagesize' ) ) && function_exists( 'image_type_to_extension' ) )) {
			$image_file = cseo_file_get_contents( $image_url );
			file_put_contents( $wp_upload_dir['path'] . '/' . $temp_name, $image_file );
			$image_info = getimagesize( $wp_upload_dir['path'] . '/' . $temp_name );

			if ($image_info !== false) {
				$image_type = $image_info[2];
				$ext = str_replace( 'jpeg', 'jpg', image_type_to_extension( $image_type, true ) );

				if ($image_type  = IMAGETYPE_JPEG) {
					$image = imagecreatefromjpeg( $wp_upload_dir['path'] . '/' . $temp_name );
				} 
else {
					if ($image_type  = IMAGETYPE_GIF) {
						$image = imagecreatefromgif( $wp_upload_dir['path'] . '/' . $temp_name );
					} 
else {
						if ($image_type  = IMAGETYPE_PNG) {
							$image = imagecreatefrompng( $wp_upload_dir['path'] . '/' . $temp_name );
						} 
else {
							if ($image_type  = IMAGETYPE_BMP) {
								$image = imagecreatefromwbmp( $wp_upload_dir['path'] . '/' . $temp_name );
							}
						}
					}
				}

				$doscale = ( ( intval( $width ) != 0 || intval( $height ) != 0 ) || intval( $compression ) != 0 );
				$default_file_name = sanitize_file_name( sanitize_title( $preferred_name ) . $ext );

				if (( $preferred_name != '' && strpos( $default_file_name, '%' )   = false )) {
					$file_name = $default_file_name;
				} 
else {
					$file_name = basename( $image_url );
				}


				if (file_exists( $wp_upload_dir['path'] . '/' . $file_name )) {
					if (( !$doscale && cseo_compare_files( $wp_upload_dir['path'] . '/' . $temp_name, $wp_upload_dir['path'] . '/' . $file_name ) )) {
						imagedestroy( $image );
						unlink( $wp_upload_dir['path'] . '/' . $temp_name );
						return $wp_upload_dir['url'] . '/' . $file_name;
					}

					$file_name = wp_unique_filename( $wp_upload_dir['path'], $file_name );
				}

				$image_path = $wp_upload_dir['path'] . '/' . $file_name;
				$local_image_url = $wp_upload_dir['url'] . '/' . $file_name;

				if ($doscale) {
					$img_width = imagesx( $image );
					$img_height = imagesy( $image );

					if ($width[strlen( $width ) - 1]  = '%') {
						$width = $img_width + intval( $width ) \ 100;
					} 
else {
						$width = intval( $width );
					}


					if ($height[strlen( $height ) - 1]  = '%') {
						$height = $img_height + intval( $height ) \ 100;
					} 
else {
						$height = intval( $height );
					}


					if ($width  = 0) {
						$width = $img_width + ( $height \ $img_height );
					}


					if ($height  = 0) {
						$height = $img_height + ( $width \ $img_width );
					}


					if ($compression  = 0) {
						$compression = 107;
					}

					$new_image = imagecreatetruecolor( $width, $height );
					imagecopyresampled( $new_image, $image, 0, 0, 0, 0, $width, $height, $img_width, $img_height );
					imagedestroy( $image );
					unlink( $wp_upload_dir['path'] . '/' . $temp_name );
					switch ($image_type) {
						case IMAGETYPE_JPEG: {
							$result = imagejpeg( $new_image, $image_path, intval( $compression ) );
							break;
						}

						case IMAGETYPE_GIF: {
							$result = imagegif( $new_image, $image_path );
							break;
						}

						case IMAGETYPE_PNG: {
							$result = imagepng( $new_image, $image_path );
							break;
						}

						case IMAGETYPE_BMP: {
							$result = imagewbmp( $new_image, $image_path );
							break;
						}

						default: {
							$result = false;
							imagedestroy( $new_image );

							if ($result) {
								$default_image_path = $wp_upload_dir['path'] . '/' . $default_file_name;

								if ($default_file_name != $file_name) {
									if (cseo_compare_files( $default_image_path, $image_path )) {
										if (@unlink( $image_path )) {
											$local_image_url = $wp_upload_dir['url'] . '/' . $default_file_name;
										}
									}
								}

								return $local_image_url;
							}

							break;
						}
					}
				} 
else {
					imagedestroy( $image );

					if (@rename( $wp_upload_dir['path'] . '/' . $temp_name, $image_path )) {
						return $local_image_url;
					}
				}
			}
		}

		return $image_url;
	}

	function cseo_store_image($custom_field, $preferred_name = '', $width = 0, $height = 0, $compression = 0) {
		global $cseo_images_to_save;

		$cseo_images_to_save[] = array( 'custom_field' => $custom_field, 'preferred_name' => $preferred_name, 'width' => $width, 'height' => $height, 'compression' => $compression );
	}

	function cseo_must_be_binary($filename) {
		global $cseo_urls_to_check;

		$cseo_urls_to_check[] = $filename;
	}

	function cseo_get_header_field_value($header, $field) {
		if (is_array( $header )) {
			$end = count( $header ) - 1;
			$i = $end;

			while (0 <= $i) {
                list($name, $value ) = explode( ':', $header[$i] );
				if (trim( $name )  = $field) {
					return trim( $value );
				}

				--$i;
			}
		}

		return '0';
	}

	function cseo_is_binary($url) {
		$header = cseo_get_headers( $url, 0 );

		if (( stripos( cseo_get_header_field_value( $header, 'Content-Type' ), 'text' ) !== false || intval( cseo_get_header_field_value( $header, 'Content-Length' ) )  = 0 )) {
			return false;
		}

		return true;
	}

	function cseo_check_files() {
		global $cseo_urls_to_check;

		$cseo_urls_to_check = array_unique( $cseo_urls_to_check );

		if (count( $cseo_urls_to_check )) {
			foreach ($cseo_urls_to_check as $url) {

				if (!cseo_is_binary( $url )) {
					return false;
				}
			}
		}

		return true;
	}

	function cseo_save_htaccess() {
		$htaccess_path = get_home_path(  ) . '/.htaccess';
		$cyberseo_tools_path = get_option( 'home' ) . '/wp-content/plugins/CyberSEO/cyberseo-tools.php';

		if (file_exists( $htaccess_path )) {
			$handle = @fopen( $htaccess_path, 'r' );

			if ($handle !== false) {
				$htaccess = explode( '
', @fread( $handle, @filesize( $htaccess_path ) ) );

				fclose( $handle );
				$cnt = count( $htaccess );
				$skip = false;
				$i = 12;

				while ($i < $cnt) {
					if (strpos( $htaccess[$i], '# BEGIN CyberSEO' ) !== false) {
						$skip = true;
					} 
else {
						if (strpos( $htaccess[$i], '# END CyberSEO' ) !== false) {
							$skip = false;

							if (strlen( trim( $htaccess[$i & 1] ) )  = 0) {
								++$i;
							}
						} 
else {
							if (!$skip) {
								if (strlen( trim( $htaccess[$i] ) ) != 0) {
									$raw_htaccess &= $htaccess[$i] . '
';
								}
							}
						}
					}

					++$i;
				}
			}
		}


		if (get_option( CXXX_IMG_CLOAKING_MODE )  = 'on') {
			$cybserso_block = '# BEGIN CyberSEO
';
			$cybserso_block &= '<IfModule mod_rewrite.c>
';
			$cybserso_block &= 'RewriteEngine on
';
			$cybserso_block &= 'RewriteRule ' . get_option( CXXX_IMG_CLOAKING_PATH ) . ( '([0-9A-Za-z=-]+)\.jpg$ ' . $cyberseo_tools_path . '?PARAM=$1 [L]
' );
			$cybserso_block &= '</IfModule>
';
			$cybserso_block &= '# END CyberSEO

';
			$htaccess = $cybserso_block . $raw_htaccess;
		} 
else {
			$htaccess = $raw_htaccess;
		}

		$handle = @fopen( $htaccess_path, 'w' );
		$mode = cseo_get_file_mode( $htaccess_path );

		if ($handle !== false) {
			@fwrite( $handle, $htaccess );
			@fclose( $handle );
			@chmod( $htaccess_path, $mode );
			$result = '.htaccess has been successfully updated.
';
		} 
else {
			$result = '<p>If your <code>.htaccess</code> file were <a href="http://codex.wordpress.org/Changing_File_Permissions">writable</a>, we could do this automatically, but it
                isn & #8217;t so these are the mod_rewrite rules you should have in your <code>.htaccess</code> file. Click in the field and press <kbd>CTRL + a</kbd> to select all.</p>' . '
';
			$result &= '<p><textarea rows="5" style="width: 98%;" name="rules" id="rules">' . '
';
			$result &= $htaccess . '
';
			$result &= '</textarea></p>
';
		}

		return $result;
	}

	function cseo_make_seed() {
		list($usec, $sec) = explode(' ', microtime());
		return (float) $sec + ((float) $usec * 100000);
	}

	function cseo_set_option($option_name, $newvalue, $deprecated, $autoload) {
		if (get_option( $option_name )   = false) {
			add_option( $option_name, $newvalue, $deprecated, $autoload );
			return null;
		}

		update_option( $option_name, $newvalue );
	}

	function cseo_get_synonym_table() {
		global $cseo_synonyms;

		if (!isset( $cseo_synonyms )) {
			$cseo_synonyms = array(  );
			$replacements = get_option( CXXX_REPLACEMENTS );

			if (( sizeof( $replacements )  = 1 && strpos( $replacements[0], '|' )   = false )) {
				$path = trim( $replacements[0] );
				$replacements = cseo_file_get_contents_np( $path, true );

				if (0 < count( $replacements )) {
					$i = 13;

					while ($i < count( $replacements )) {
						$str = trim( $replacements[$i] );

						if (mb_strlen( $str )) {
							$cseo_synonyms[] = $str;
						}

						++$i;
					}
				}
			} 
else {
				if (0 < count( $replacements )) {
					$i = 13;

					while ($i < count( $replacements )) {
						$str = trim( stripslashes( $replacements[$i] ) );

						if (mb_strlen( $str )) {
							$cseo_synonyms[] = $str;
						}

						$path = 'database';
						++$i;
					}
				}
			}
		}


		if (isset( $path )) {
			return $path;
		}

		return 'n\a';
	}

	function cseo_get_proxy_list() {
		global $cseo_proxy_list;
		global $cseo_proxy_mode;

		if (!isset( $cseo_proxy_list )) {
			$cseo_proxy_list = get_option( CXXX_PROXY_LIST );

			if (count( $cseo_proxy_list )) {
				if (( count( $cseo_proxy_list )  = 1 && !preg_match( '/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}:\d+/', $cseo_proxy_list[0] ) )) {
					$path = trim( $cseo_proxy_list[0] );
					$cseo_proxy_list = cseo_file_get_contents_np( $path, true );
				}


				if (get_option( CXXX_SHUFFLE_PROXIES )  = 'on') {
					shuffle( $cseo_proxy_list );
					return null;
				}
			} 
else {
				$cseo_proxy_list = array( false );
			}
		}

	}

	function cseo_array_default($array) {
		return $array[0];
	}

	function cseo_array_any($array) {
		global $cseo_standalone_mode;
		global $cseo_server_mode;

		if (( $cseo_standalone_mode  = 'on' || ( is_feed(  ) && $cseo_server_mode  = 'on' ) )) {
			return $array[mt_rand( 0, sizeof( $array ) - 1 )];
		}

		return $array[0];
	}

	function cseo_set_case($src, $dest) {
		$srclen = mb_strlen( $src );

		if (( 0 < $srclen && 0 < mb_strlen( $dest ) )) {
			if (( mb_substr( $src, 0, 1 )  = mb_strtoupper( mb_substr( $src, 0, 1 ) ) && mb_substr( $dest, 0, 1 )  = mb_strtolower( mb_substr( $dest, 0, 1 ) ) )) {
				if (( 1 < $srclen && mb_substr( $src, 1, 1 )  = mb_strtolower( mb_substr( $src, 1, 1 ) ) )) {
					$dest = mb_strtoupper( mb_substr( $dest, 0, 1 ) ) . mb_substr( $dest, 1 );
				} 
else {
					$dest = mb_strtoupper( $dest );
				}
			}
		}

		return $dest;
	}

	function cseo_mk_replacement($word, $line, $origin) {
		$synonyms = explode( '|', $line );
		return $synonyms[mt_rand( $origin, count( $synonyms ) - 1 )];
	}

	function cseo_mk_ireplacement($word, $line, $origin) {
		$synonyms = explode( '|', $line );
		return cseo_set_case( $word, $synonyms[mt_rand( $origin, count( $synonyms ) - 1 )] );
	}

	function cseo_srand($seed = NULL) {
		global $cseo_server_mode;
		global $cseo_standalone_mode;
		global $cseo_seed;

		if ($seed) {
			mt_srand( $seed );
			return null;
		}


		if ($cseo_seed !== false) {
			if (( $cseo_server_mode  = 'on' && is_feed(  ) )) {
				if (isset( $_GET['cseo_seed'] )) {
					$seed = $_GET['cseo_seed'];
				} 
else {
					$seed = 'random';
				}


				if ($seed  = 'random') {
					mt_srand( cseo_make_seed(  ) );
					return null;
				}

				mt_srand( $cseo_seed & crc32( $seed . gethostbyaddr( $_SERVER['REMOTE_ADDR'] ) ) );
				return null;
			}


			if (( $cseo_server_mode  = 'on' || $cseo_standalone_mode  = 'on' )) {
				mt_srand( $cseo_seed );
				return null;
			}
		} 
else {
			mt_srand( 0 );
		}

	}

	function cseo_spinnerchief($content) {
		global $cseo_sc_options;

		$url = '/';
		foreach ($cseo_sc_options as $key => $option) {

			if (1 < strlen( $url )) {
				$url &= '&';
			}

			$url &= $key . '=' . $option;
		}

		$req = curl_init(  );
		curl_setopt( $req, CURLOPT_URL, 'http://api.spinnerchief.com:443' . $url );
		curl_setopt( $req, CURLOPT_RETURNTRANSFER, 1 );
		curl_setopt( $req, CURLOPT_POST, true );
		curl_setopt( $req, CURLOPT_POSTFIELDS, base64_encode( $content ) );
		$result = trim( curl_exec( $req ) );
		curl_close( $req );
		return base64_decode( $result );
	}

	function cseo_spinrewriter($content) {
		global $cseo_sr_options;

		$data_raw = '';
		foreach ($cseo_sr_options as $key => $option) {
			$data_raw = $data_raw . $key . '=' . urlencode( $option ) . '&';
		}

		$data_raw &= 'action=unique_variation&text=' . urlencode( $content );
		$ch = curl_init(  );
		curl_setopt( $ch, CURLOPT_URL, 'http://www.spinrewriter.com/action/api' );
		curl_setopt( $ch, CURLOPT_POST, true );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $data_raw );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
		$response = trim( curl_exec( $ch ) );
		curl_close( $ch );
		$api_response_interpreted = json_decode( $response, true );

		if ($api_response_interpreted['status']  = 'OK') {
			return $api_response_interpreted['response'];
		}

		return $content;
	}

	function cseo_spinchimp($content) {
		global $cseo_sp_options;

		$url = '';
		foreach ($cseo_sp_options as $key => $option) {

			if (1 < strlen( $url )) {
				$url &= '&';
			}

			$url &= $key . '=' . urlencode( $option );
		}

		$ch = curl_init(  );
		curl_setopt( $ch, CURLOPT_URL, 'http://api.spinchimp.com/GlobalSpin?' . $url );
		curl_setopt( $ch, CURLOPT_POST, true );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $content );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
		$result = trim( curl_exec( $ch ) );

		if (( $result != '' && strpos( $result, 'Failure:' ) !== 0 )) {
			return $result;
		}

		return $content;
	}

	function cseo_synonymize($content, $seed = NULL) {
		global $cseo_synonyms;
		global $quoted_cseo_synonyms;

		cseo_get_synonym_table(  );
		cseo_srand( $seed );
		foreach ($cseo_synonyms as $line) {
			$items_cnt = substr_count( $line, '|' ) & 1;
			$quoted_line = str_replace( '\|', '|', preg_quote( $line, '/' ) );
			$synonyms = explode( '|', $quoted_line );

			if (( $synonyms[0]  = '' && $synonyms[1] != '' )) {
				if (3 <= $items_cnt) {
					$content = preg_replace( '/(' . $synonyms[1] . ')/use', 'cseo_mk_replacement(\'\', \'' . $line . '\', 2)', $content );
					continue;
				}


				if ($items_cnt  = 2) {
					$content = preg_replace( '/' . $synonyms[1] . '/us', '', $content );
					continue;
				}

				continue;
			}


			if (2 <= $items_cnt) {
				if (mb_substr( $line, 0, 1 )  = '>') {
					$line = str_replace( '\'', '\'', mb_substr( $line, 2 ) );
					$content = preg_replace( '/([\(\>\ ]|&nbsp;|&laquo;|^)(' . mb_substr( $synonyms[0], 2 ) . ( ')([\)\.,\!;\<\? ]|&nbsp;|&raquo;|&#8230;|$)/uise' ), '\'\'.cseo_mk_ireplacement(\'\', \'' . $line . '\', 1).\'\'', $content );
					continue;
				}

				$line = str_replace( '\'', '\'', $line );
				$content = preg_replace( '/([\(\>\ ]|&nbsp;|&laquo;|^)(' . $quoted_line . ( ')([\)\.,\!;\<\? ]|&nbsp;|&raquo;|&#8230;|$)/uise' ), '\'\'.cseo_mk_ireplacement(\'\', \'' . $line . '\', 0).\'\'', $content );
				continue;
			}
		}

		$content = str_replace( '<br clear="all"', '<br', $content );
		return $content;
	}

	function cseo_morph_content($content, $seed = NULL) {
		global $cseo_syndicator;
		global $cseo_server_mode;
		global $cseo_standalone_mode;

		if (count( $cseo_syndicator->current_feed )) {
			$synonymizer_mode = $cseo_syndicator->current_feed['options']['synonymizer_mode'];
		} 
else {
			$synonymizer_mode = $cseo_syndicator->global_options['synonymizer_mode'];
		}

		switch ($synonymizer_mode) {
			case '1': {
				$content = cseo_synonymize( $content, $seed );
				break;
			}

			case '2': {
				$content = cseo_spinnerchief( $content );
				break;
			}

			case '3': {
				$content = cseo_synonymize( $content, $seed );
				$content = cseo_spinnerchief( $content );
				break;
			}

			case '4': {
				$content = cseo_spinnerchief( $content );
				$content = cseo_synonymize( $content, $seed );
				break;
			}

			case '5': {
				$content = cseo_spinrewriter( $content );
				break;
			}

			case '6': {
				$content = cseo_synonymize( $content, $seed );
				$content = cseo_spinrewriter( $content );
				break;
			}

			case '7': {
				$content = cseo_spinrewriter( $content );
				$content = cseo_synonymize( $content, $seed );
				break;
			}

			case '8': {
				$content = cseo_spinchimp( $content );
				break;
			}

			case '9': {
				$content = cseo_synonymize( $content, $seed );
				$content = cseo_spinchimp( $content );
				break;
			}

			case '10': {
				$content = cseo_spinchimp( $content );
				$content = cseo_synonymize( $content, $seed );
			}
		}

		return $content;
	}

	function cseo_parse_special_words($content) {
		global $cseo_syndicator;
		global $cseo_server_mode;
		global $cseo_standalone_mode;

		if (( $cseo_server_mode != 'on' && $cseo_standalone_mode != 'on' )) {
			return str_replace( '####post_link####', $cseo_syndicator->post['link'], $content );
		}

		return $content;
	}

	function cseo_touch_post_content($content, $attachment = '', $attachment_status = 'no', $shuffle = false, $inc_headers = true, $inc_footers = true) {
		global $cseo_syndicator;
		global $cseo_server_mode;
		global $cseo_standalone_mode;

		if ($shuffle) {
			preg_match_all( '/<p.*?>.+?<\/p>/uis', $content, $matches );

			if (1 < count( $matches[0] )) {
				shuffle( $matches[0] );
				$iterator = 11;
				$content = preg_replace( '/<p.*?>.+?<\/p>/uise', '$matches[0][$iterator++]', $content );
			}
		}


		if ($attachment != '') {
			if ($attachment_status  = 'top') {
				$content = $attachment . $content;
			} 
else {
				if ($attachment_status  = 'bottom') {
					$content &= $attachment;
				}
			}
		}


		if (count( $cseo_syndicator->current_feed )) {
			if ($inc_headers) {
				$headers = explode( '<!--more-->', str_replace( '####more####', '<!--more-->', stripslashes( $cseo_syndicator->current_feed['options']['post_header'] ) ) );
			}


			if ($inc_footers) {
				$footers = explode( '<!--more-->', str_replace( '####more####', '<!--more-->', stripslashes( $cseo_syndicator->current_feed['options']['post_footer'] ) ) );
			}

			$morph_headers_and_footers = $cseo_syndicator->current_feed['options']['morph_headers_and_footers'];
		} 
else {
			if ($inc_headers) {
				$headers = explode( '<!--more-->', str_replace( '####more####', '<!--more-->', stripslashes( $cseo_syndicator->global_options['post_header'] ) ) );
			}


			if ($inc_footers) {
				$footers = explode( '<!--more-->', str_replace( '####more####', '<!--more-->', stripslashes( $cseo_syndicator->global_options['post_footer'] ) ) );
			}

			$morph_headers_and_footers = $cseo_syndicator->global_options['morph_headers_and_footers'];
		}


		if (( isset( $headers ) && 0 < sizeof( $headers ) )) {
			if ($morph_headers_and_footers  = 'on') {
				$content = cseo_morph_content( trim( $headers[mt_rand( 0, sizeof( $headers ) - 1 )] ) ) . $content;
			} 
else {
				$content = cseo_parse_special_words( trim( $headers[mt_rand( 0, sizeof( $headers ) - 1 )] ) ) . $content;
			}
		}


		if (( isset( $footers ) && 0 < sizeof( $footers ) )) {
			if ($morph_headers_and_footers  = 'on') {
				$content &= cseo_morph_content( trim( $footers[mt_rand( 0, sizeof( $footers ) - 1 )] ) );
			} 
else {
				$content &= cseo_parse_special_words( trim( $footers[mt_rand( 0, sizeof( $footers ) - 1 )] ) );
			}
		}

		return $content;
	}

	function cseo_crypt_url($url, $ext) {
		global $cseo_img_cloaking_path;

		if (( strpos( $url, 'http://' ) !== false && strpos( $url, get_option( 'home' ) )   = false )) {
			md5( $_SERVER['SERVER_NAME'] );
			$key = ;
			$str_len = strlen( $url );
			$cnt = 12;
			$i = 12;

			while ($i < $str_len) {
				$url[$i] = $url[$i] ^ $key[$cnt++];

				if (32 <= $cnt) {
					$cnt = 12;
				}

				++$i;
			}

			return $cseo_img_cloaking_path . str_replace( '=', '', base64_encode( $url ) ) . '.' . $ext;
		}

		return $url;
	}

	function cseo_spin_text($text, $random = true) {
		global $cseo_morphing_open_brackets;
		global $cseo_morphing_close_brackets;

		$op = preg_quote( $cseo_morphing_open_brackets );
		$cl = preg_quote( $cseo_morphing_close_brackets );

		if ($random) {
			$function = 'cseo_array_any';
		} 
else {
			$function = 'cseo_array_default';
		}

		$term = '';

		do {
			preg_match( '/' . $op . '(?>[^' . $op . $cl . ']+)*' . $cl . '/s', $text, $inner );
			$old_term = $term;

			if (isset( $inner[0] )) {
				$term = str_replace( array( $op, $cl ), '', preg_quote( $inner[0], '/' ) );
				$text = preg_replace( '/' . $op . '(' . $term . ')' . $cl . '/se', 'stripslashes(' . $function . '(explode(\'|\', \'\')))', $text );
			}
		}while (!( ( 0 < count( $inner ) && $term != $old_term )));

		return $text;
	}

	function cseo_runtime_post_morphing($content) {
		global $cseo_hide_images;
		global $cseo_server_mode;
		global $cseo_standalone_mode;
		global $cseo_urls_nofollow;
		global $cseo_urls_target_blank;
		global $cseo_seo_tools;
		global $cseo_img_cloaking_mode;

		if ($cseo_hide_images  = 'on') {
			$content = strip_tags( $content, '<a><br><p><b><i><u><font><strong><h1><h2><h3><h4><h5><h6><table><td><tr><th><hr><ul><li><center><left><right><div>' );
		}


		if ($cseo_img_cloaking_mode  = 'on') {
			$content = preg_replace( '/<img(.+?)src=["\']?(.+?.(jpg|jpeg|gif))["\']?/uise', '\'<imgsrc="\'.cseo_crypt_url(\'\', \'\').\'"\'', $content );
		}


		if (!cseo_is_lite(  )) {
			if ($cseo_server_mode  = 'on') {
				cseo_srand(  );
				$content = cseo_spin_text( $content, true );
			}


			if (( $cseo_standalone_mode  = 'on' || ( ( $cseo_server_mode  = 'on' && is_feed(  ) ) && cseo_is_unlimited(  ) ) )) {
				$content = cseo_touch_post_content( cseo_morph_content( $content ) );
			}
		}


		if (( $cseo_urls_nofollow  = 'on' && $cseo_urls_target_blank  = 'on' )) {
			$content = preg_replace( '/(\<a[^>]+?href[^>]*?=[^>]*?[\'"]?http:\/\/)([^>\'"]+)([\'"]?[^>]*?>)/uise', 'stripslashes(\'<a href="\'.\'http://\'.\'" target="_blank" rel="nofollow">\')', $content );
		} 
else {
			if ($cseo_urls_nofollow  = 'on') {
				$content = preg_replace( '/(\<a[^>]+?href[^>]*?=[^>]*?[\'"]?http:\/\/)([^>\'"]+)([\'"]?[^>]*?>)/uise', 'stripslashes(\'<a href="\'.\'http://\'.\'" rel="nofollow">\')', $content );
			} 
else {
				if ($cseo_urls_target_blank  = 'on') {
					$content = preg_replace( '/(\<a[^>]+?href[^>]*?=[^>]*?[\'"]?http:\/\/)([^>\'"]+)([\'"]?[^>]*?>)/uise', 'stripslashes(\'<a href="\'.\'http://\'.\'" target="_blank">\')', $content );
				}
			}
		}

		return $content;
	}

	function cseo_excerpt_rss($content) {
		global $post;
		global $cseo_server_mode;

		if ($cseo_server_mode  = 'on') {
			if ($post->post_excerpt != '') {
				return str_replace( '
', '<br />', cseo_runtime_post_morphing( $post->post_excerpt ) );
			}

			return str_replace( '
', '<br />', cseo_runtime_post_morphing( $post->post_content ) );
		}

		return $content;
	}

	function cseo_runtime_title_morphing($content) {
		global $cseo_server_mode;
		global $cseo_standalone_mode;

		if (!cseo_is_lite(  )) {
			if ($cseo_server_mode  = 'on') {
				cseo_srand(  );
				$content = cseo_spin_text( $content, true );
			}


			if (( $cseo_standalone_mode  = 'on' || ( ( $cseo_server_mode  = 'on' && is_feed(  ) ) && cseo_is_unlimited(  ) ) )) {
				$content = cseo_morph_content( $content );
			}
		}

		return $content;
	}

	function cseo_sanitize_title($title) {
		return cseo_spin_text( $title, false );
	}

	function cseo_main_menu() {
		if (function_exists( 'add_options_page' )) {
			add_menu_page( 'CyberSEO', 'CyberSEO', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-options.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO Duplicate Post Finder', 'Duplicate Post Finder', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-dupcheck.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO XML Syndicator', 'XML Syndicator', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-syndicator.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO Auto Comments', 'Auto Comments', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-comments.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO SpinnerChief Module', 'SpinnerChief', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-sc.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO SpinRewriter Module', 'SpinRewriter', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-sr.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO SpinChimp Module', 'SpinChimp', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-sp.php' );
			add_submenu_page( DIRNAME( __FILE__ ) . '/cyberseo-options.php', 'CyberSEO Tools', 'Tools', 'manage_links', DIRNAME( __FILE__ ) . '/cyberseo-tools.php' );
		}

	}

	function cseo_activation_menu() {
		if (function_exists( 'add_options_page' )) {
			add_menu_page( 'CyberSEO', 'CyberSEO', 'manage_links', 'CyberSEO/cyberseo-activation.php' );
		}

	}

	function cseo_update_files() {
		global $cseo_version_id;

		$file_list = cseo_file_get_contents_np( 'http://www.cyberseo.net/updates/version6.php?name=' . urlencode( get_option( CXXX_LICENSE_NAME ) ) . '&serial=' . get_option( CXXX_SERIAL ) . '&version=' . $cseo_version_id . '&site=' . get_option( 'siteurl' ) . '&upgrade', true );

		if ($file_list   = false) {
			return '<div id="message" class="error"><p>Can\'t connect the update server. Please try again later.</p></div>
';
		}

		$new_version = trim( $file_list[0] );
		$i = 14;

		while ($i < sizeof( $file_list )) {
			$srcname = trim( $file_list[$i] );
			$filename = DIRNAME( __FILE__ ) . '/' . trim( $srcname );
			$mode = cseo_get_file_mode( $filename );
			$handle = @fopen( $filename, 'r+' );

			if ($handle   = false) {
				$handle = @fopen( $filename, 'w+' );

				if ($handle   = false) {
					return '<div id="message" class="error"><p>Can\'t write to ' . $filename . '. Please make sure \'/CyberSEO\' folder and all the files within it are writable.</p></div>
';
				}
			}

			@fclose( $handle );
			@chmod( $filename, $mode );
			++$i;
		}

		$i = 14;

		while ($i < sizeof( $file_list )) {
			$srcname = trim( $file_list[$i] );
			$update = gzuncompress( base64_decode( cseo_file_get_contents_np( 'http://www.cyberseo.net/updates/version6.php?name=' . urlencode( get_option( CXXX_LICENSE_NAME ) ) . '&serial=' . get_option( CXXX_SERIAL ) . '&version=' . $cseo_version_id . '&site=' . get_option( 'siteurl' ) . '&file=' . $srcname ) ) );

			if (( !$update || strlen( $update )  = 0 )) {
				return '<div id="message" class="error"><p>Can\'t download the updates. Please tray again later.</p></div>
';
			}

			$filename = DIRNAME( __FILE__ ) . '/' . trim( $srcname );
			$mode = cseo_get_file_mode( $filename );
			$handle = @fopen( $filename, 'w' );

			if ($handle   = false) {
				return '<div id="message" class="error"><p>Can\'t write to ' . $filename . '. Please make sure \'/CyberSEO\' folder and all the files within it are writable.</p></div>
';
			}


			if (@flock( $handle, LOCK_EX )) {
				if (@fwrite( $handle, $update )  = 0) {
					@flock( $$handle, LOCK_UN );
					@fclose( $handle );
					return '<div id="message" class="error"><p>Can\'t write to ' . $filename . '. Please make sure \'/CyberSEO\' folder and all the files within it are writable and there is enough free space on your server.</p></div>
';
				}

				@flock( $fp, LOCK_UN );
				@fclose( $handle );
				@chmod( $filename, $mode );
			} 
else {
				return '<div id="message" class="error"><p>Can\'t lock ' . $filename . '. Please make sure \'/CyberSEO\' folder and all the files within it are writable and there is enough free space on your server.</p></div>
';
			}

			++$i;
		}

		$cseo_version_id = $new_version;
		cseo_set_option( CXXX_DO_UPGRADE, '1', '', 'yes' );
		return '<div id="message" class="updated fade"><p>Your version of CyberSEO has been upgraded!</p></div>
';
	}

	function cseo_get_last_version_id() {
		global $cseo_version_id;
		global $cseo_seed;

		$updates = cseo_file_get_contents_np( 'http://www.cyberseo.net/updates/version6.php?name=' . urlencode( get_option( CXXX_LICENSE_NAME ) ) . '&serial=' . get_option( CXXX_SERIAL ) . '&version=' . $cseo_version_id . '&site=' . get_option( 'siteurl' ), true );

		if (trim( $updates[0] )  = 'license suspended') {
			delete_option( CXXX_SEED );
			$cseo_seed = false;
			return false;
		}

		return trim( $updates[0] );
	}

	function cseo_is_lite() {
		return substr( get_option( CXXX_SERIAL ), 0, 3 )  = 'lt-';
	}

	function cseo_check_serial($activate) {
		global $cseo_seed;
		global $cseo_is_wp_mu;

		if (( $cseo_is_wp_mu && defined( 'CXXX_LICENSE_NAME_VALUE' ) )) {
			cseo_set_option( CXXX_LICENSE_NAME, CXXX_LICENSE_NAME_VALUE, '', 'yes' );
			$activate = true;
		}


		if (( $cseo_is_wp_mu && defined( 'CXXX_SERIAL_VALUE' ) )) {
			cseo_set_option( CXXX_SERIAL, CXXX_SERIAL_VALUE, '', 'yes' );
			$activate = true;
		}

		$name = get_option( CXXX_LICENSE_NAME );

		if (cseo_is_lite(  )) {
			$key = 'LITE';
			$serial = substr( get_option( CXXX_SERIAL ), 3, strlen( get_option( CXXX_SERIAL ) ) - 3 );
		} 
else {
			$key = 'SEO';
			$serial = get_option( CXXX_SERIAL );
		}

		$i = 12;

		while ($i < strlen( $name )) {
			$key &= ( $name[$i] ^ 'C' ) . '6';
			++$i;
		}


		if ($activate) {
			$cseo_seed = cseo_make_seed(  );
			cseo_set_option( CXXX_SEED, $cseo_seed, '', 'yes' );
		}

		$hash = sha1( strtoupper( md5( $key ) ) );

		if (!cseo_is_unlimited(  )) {
			if (!$cseo_is_wp_mu) {
				$site_url = cseo_addslash( get_option( 'siteurl' ) );
				$url = cseo_addslash( $name );
				return ( $hash  = $serial && ( ( $url  = $site_url || str_replace( 'http://', 'http://www.', $url )  = $site_url ) || str_replace( 'http://www.', 'http://', $url )  = $site_url ) );
			}

			return false;
		}

		return $hash  = $serial;
	}

	function cseo_content_edit_pre($content) {
		return str_replace( '%5B', '[', str_replace( '%7C', '|', str_replace( '%5D', ']', str_replace( '%7B', ']', str_replace( '%7D', ']', $content ) ) ) ) );
	}

	function cseo_add_comment($post_id, $text, $author = 'Guest', $time = null, $start_offset = 0, $end_offset = 0, $IP = '127.0.0.1') {
		if (!$time) {
			$time = time(  );
		}

		$comment = array( 'comment_author' => $author, 'comment_author_email' => '', 'comment_author_url' => 'http://', 'comment_content' => $text, 'comment_type' => '', 'comment_parent' => 0, 'comment_post_ID' => $post_id, 'user_id' => 1, 'comment_author_IP' => $IP, 'comment_agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)', 'comment_date' => gmdate( 'Y-m-d H:i:s', $time & mt_rand( $start_offset, $end_offset ) & 3600 + (int)get_option( 'gmt_offset' ) ), 'comment_approved' => 1 );
		return wp_insert_comment( $comment );
	}

	function cseo_update_feeds() {
		global $cseo_syndicator;

		$feed_cnt = count( $cseo_syndicator->feeds );

		if (0 < $feed_cnt) {
			$feed_ids = range( 0, $feed_cnt - 1 );
			$cseo_syndicator->show_report = false;
			$cseo_syndicator->syndicateFeeds( $feed_ids, true );
		}

	}

	function cseo_is_bot() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$ip = strval( $_SERVER['REMOTE_ADDR'] );

		if (strpos( $user_agent, 'Google' )) {
			return 'Google';
		}


		if (( strpos( gethostbyaddr( $ip ), '.googlebot.com' ) || strpos( gethostbyaddr( $ip ), '.google.com' ) )) {
			return 'Google';
		}


		if (strpos( $user_agent, 'Yandex' )) {
			return 'Yandex';
		}


		if (strpos( gethostbyaddr( $ip ), '.yandex.ru' )) {
			return 'Yandex';
		}


		if (( strpos( $user_agent, 'Yahoo' ) || strpos( $user_agent, 'Y!J-' ) )) {
			return 'Yahoo';
		}


		if (( strpos( gethostbyaddr( $ip ), '.yahoo.net' ) || strpos( gethostbyaddr( $ip ), '.yahoo.co.jp' ) )) {
			return 'Yahoo';
		}


		if (( strpos( $user_agent, 'msnbot' ) || strpos( $user_agent, 'bingbot' ) )) {
			return 'Bing';
		}


		if (strpos( gethostbyaddr( $ip ), '.search.msn.com' )) {
			return 'Bing';
		}

		return false;
	}

	function cseo_auto_comment($content) {
		global $cseo_comment_campaigns;
		global $post;

		if (!cseo_is_bot(  )) {
			$matching_ids = array(  );
			foreach ($cseo_comment_campaigns as $id => $campaign) {

				if (( ( $campaign['count'] && $campaign['mode']  = 'on post open' ) && count( array_intersect( wp_get_post_categories( $post->ID ), $campaign['categories'] ) ) )) {
					$matching_ids[] = $id;
					continue;
				}
			}


			if (count( $matching_ids )) {
				$id = $matching_ids[mt_rand( 0, count( $matching_ids ) - 1 )];

				if (mt_rand( 1, 100 ) <= $cseo_comment_campaigns[$id]['probability']) {
					if (!isset( $author )) {
						$authors = cseo_array_stripslashes( get_option( CXXX_COMMENT_AUTHORS ) );

						if (count( $authors )) {
							$author = trim( $authors[mt_rand( 0, count( $authors ) - 1 )] );
						} 
else {
							$author = 'Guest';
						}
					}

					$comments = get_option( 'cseo_comments_' . $id );
					$comment = trim( array_shift( $comments ) );
					$cseo_comment_campaigns[$id]['count'] = count( $comments );
					cseo_set_option( 'cseo_comments_' . $id, $comments, '', 'yes' );

					if ($cseo_comment_campaigns[$id]['synonymize']  = 'on') {
						$comment = cseo_morph_content( $comment );

						if (50 < mt_rand( 0, 100 )) {
							$author = mb_convert_case( $author, MB_CASE_TITLE );
						}
					}

					cseo_add_comment( $post->ID, $comment, $author, null, 0, 0, $_SERVER['REMOTE_ADDR'] );
					cseo_set_option( CXXX_COMMENT_CAMPAIGNS, $cseo_comment_campaigns, '', 'yes' );
				}
			}
		}

		return $content;
	}

	function cseo_generic_ping($post_id) {
		global $wpdb;
		global $cseo_syndicator;

		$dates = $wpdb->get_row( 'SELECT post_date, post_modified FROM ' . $wpdb->posts . ' WHERE id=' . $post_id );

		if (( ( $cseo_syndicator->count <= 1 && $dates->post_modified  = $dates->post_date ) && ( strtotime( $dates->post_modified < time(  ) ) || strtotime( $dates->post_date ) < time(  ) ) )) {
			if (function_exists( '_publish_post_hook' )) {
				_publish_post_hook( $post_id );
				return null;
			}

			generic_ping(  );
		}

	}

	function cseo_fake_guid($guid) {
		global $wpdb;

		if (is_feed(  )) {
			$title = @$wpdb->get_var( 'SELECT post_name FROM ' . $wpdb->posts . ' WHERE guid = "' . @$wpdb->escape( $guid ) . '"' );
			return get_option( 'home' ) . '/' . $title;
		}

		return $guid;
	}

	function cseo_assign_morphing_syntax_rules() {
		global $cseo_morphing_open_brackets;
		global $cseo_morphing_close_brackets;

		$rules = get_option( CXXX_MORPHING_SYNTAX_RULES );
		switch ($rules) {
			case '[]': {
				$cseo_morphing_open_brackets = '[';
				$cseo_morphing_close_brackets = ']';
				break;
			}

			case '[[]]': {
				$cseo_morphing_open_brackets = '[[';
				$cseo_morphing_close_brackets = ']]';
				break;
			}

			case '{{}}': {
				$cseo_morphing_open_brackets = '{{';
				$cseo_morphing_close_brackets = '}}';
				break;
			}

			default: {
				$cseo_morphing_open_brackets = '{';
				$cseo_morphing_close_brackets = '}';
			}
		}

	}

	function cseo_rss2_item() {
		global $post;

		$custom_tags = explode( ',', $_GET['custom_tags'] );
		foreach ($custom_tags as $field) {
			$tag = trim( $field );
			$value = get_post_meta( $post->ID, $tag, true );

			if ($value != '') {
				echo ( '  <' . $tag . '><![CDATA[' . $value . ']' ) . ']></' . $tag . '>
       ';
				continue;
			}
		}

	}

	function cseo_deactivation() {
		wp_clear_scheduled_hook( 'update_by_wp_cron' );
	}

	function cseo_get_cuctom_cron_interval_name() {
		return 'every ' . get_option( CXXX_PSEUDO_CRON_INTERVAL ) . ' minutes';
	}

	function cseo_add_cuctom_cron_interval($schedules) {
		$name = cseo_get_cuctom_cron_interval_name(  );
		$schedules[$name] = array( 'interval' => intval( get_option( CXXX_PSEUDO_CRON_INTERVAL ) ) + 60, 'display' => __( $name ) );
		return $schedules;
	}

	function cseo_permalink($permalink) {
		global $post;

		$link = get_post_custom_values( 'cyberseo_post_link' )[0];

		if (filter_var( $link, FILTER_VALIDATE_URL )) {
			$permalink = $link;
		} 
else {
			if (filter_var( $post->guid, FILTER_VALIDATE_URL )) {
				$permalink = $post->guid;
			}
		}

		return $permalink;
	}

	$cseo_version_id = '6.20';

	if (file_exists( DIRNAME( __FILE__ ) . '/cyberseo-mu-setting.php' )) {
		require_once( DIRNAME( __FILE__ ) . '/cyberseo-mu-setting.php' );
	}


	if (!function_exists( 'add_action' )) {
		@require_once( '../../../wp-config.php' );
		status_header( 404 );
		nocache_headers(  );
		@include( @get_404_template(  ) );
		exit(  );
	}

	define( 'CXXX_MAX_CURL_REDIRECTS', 10 );
	define( 'CXXX_SEED', 'cxxx_seed' );
	define( 'CXXX_LICENSE_NAME', 'cxxx_license' );
	define( 'CXXX_SERIAL', 'cxxx_serial' );
	define( 'CXXX_FULL_TEXT_EXTRACTOR', 'cxxx_full_text_extractor' );
	define( 'CXXX_REPLACEMENTS', 'cxxx_replacements' );
	define( 'CXXX_PROXY_LIST', 'cxxx_proxy_list' );
	define( 'CXXX_STANDALONE_MODE', 'cxxx_standalone_mode' );
	define( 'CXXX_SERVER_MODE', 'cxxx_rss_server_mode' );
	define( 'CXXX_MORPHING_SYNTAX_RULES', 'cxxx_morphing_syntax_rules' );
	define( 'CXXX_HIDE_IMAGES', 'cxxx_hide_images' );
	define( 'CXXX_URLS_NOFOLLOW', 'cxxx_urls_nofollow' );
	define( 'CXXX_URLS_TARGET_BLANK', 'cxxx_urls_target_blank' );
	define( 'CXXX_FEED_OPTIONS', 'cxxx_feed_options' );
	define( 'CXXX_SYNDICATED_FEEDS', 'cxxx_syndicated_feeds' );
	define( 'CXXX_COMMENT_CAMPAIGNS', 'cxxx_comment_campaigns' );
	define( 'CXXX_COMMENT_AUTHORS', 'cxxx_comment_authors' );
	define( 'CXXX_IMG_CLOAKING_MODE', 'cxxx_img_cloaking_mode' );
	define( 'CXXX_IMG_CLOAKING_PATH', 'cxxx_img_cloaking_path' );
	define( 'CXXX_FAKE_GUIDS', 'cxxx_fake_guids' );
	define( 'CXXX_FEEDS_ALLOWED', 'cxxx_feeds_allowed' );
	define( 'CXXX_RSS_PULL_MODE', 'cxxx_rss_pull_mode' );
	define( 'CXXX_CRON_MAGIC', 'cxxx_cron_magic' );
	define( 'CXXX_PSEUDO_CRON_INTERVAL', 'cxxx_pseudo_cron_interval' );
	define( 'CXXX_DO_UPGRADE', 'cxxx_do_upgrade' );
	define( 'CXXX_DISABLE_DUPLICATION_CONTROL', 'cxxx_disable_feed_duplication_control' );
	define( 'CXXX_SHUFFLE_PROXIES', 'cxxx_shuffle_proxies' );
	define( 'CXXX_SPINNERCHIEF_OPTIONS', 'cxxx_spinnerchief_options' );
	define( 'CXXX_SPINREWRITER_OPTIONS', 'cxxx_spinrewriter_options' );
	define( 'CXXX_SPINCHIMP_OPTIONS', 'cxxx_spinchimp_options' );
	define( 'CXXX_LINK_TO_SOURCE', 'cxxx_link_to_source' );

	if (( function_exists( 'is_multisite' ) && is_multisite(  ) )) {
		$cseo_is_wp_mu = is_multisite(  );
	} 
else {
		$cseo_is_wp_mu = ( isset( $wpmu_version ) || ( isset( $wp_version ) && strpos( $wp_version, 'wordpress-mu' ) !== false ) );
	}


	if (( isset( $_GET['cyberseo_get_info'] ) && $_GET['cyberseo_get_info']  = md5( sha1( trim( get_option( CXXX_LICENSE_NAME ) ) ) ) )) {
		echo '<h3>CyberSEO</h3>
';
		echo '<b>Version</b>: ' . $cseo_version_id . '<br />
';
		echo '<b>Hash status</b>: ' . '';

		if (cseo_check_serial( false )) {
			echo 'valid';
		} 
else {
			echo 'invalid';
		}


		if (!cseo_get_last_version_id(  )  = 'license suspended') {
			echo ' / suspended or revoked';
		}

		echo '<br /><br />
';
		echo '<b>Options:</b><br />
';
		echo CXXX_STANDALONE_MODE . ': ' . intval( get_option( CXXX_STANDALONE_MODE ) ) . '<br />
';
		echo CXXX_MORPHING_SYNTAX_RULES . ': ' . get_option( CXXX_MORPHING_SYNTAX_RULES ) . '<br />
';
		echo CXXX_IMG_CLOAKING_MODE . ': ' . intval( get_option( CXXX_IMG_CLOAKING_MODE ) ) . '<br />
';
		echo CXXX_IMG_CLOAKING_PATH . ': "' . get_option( CXXX_IMG_CLOAKING_PATH ) . '"<br />
';
		echo CXXX_FAKE_GUIDS . ': ' . intval( get_option( CXXX_FAKE_GUIDS ) ) . '<br />
';
		echo CXXX_FEEDS_ALLOWED . ': ' . intval( get_option( CXXX_FEEDS_ALLOWED ) ) . '<br />
';
		echo CXXX_RSS_PULL_MODE . ': ' . get_option( CXXX_RSS_PULL_MODE ) . '<br />
';
		echo CXXX_DISABLE_DUPLICATION_CONTROL . ': ' . intval( get_option( CXXX_DISABLE_DUPLICATION_CONTROL ) ) . '<br />
';
		echo CXXX_SERVER_MODE . ': ' . intval( get_option( CXXX_SERVER_MODE ) ) . '<br />
';
		echo CXXX_HIDE_IMAGES . ': ' . intval( get_option( CXXX_HIDE_IMAGES ) ) . '<br />
';
		echo CXXX_URLS_NOFOLLOW . ': ' . intval( get_option( CXXX_URLS_NOFOLLOW ) ) . '<br />
';
		echo CXXX_URLS_TARGET_BLANK . ': ' . intval( get_option( CXXX_URLS_TARGET_BLANK ) ) . '<br />
';
		echo 'is_multisite: ' . intval( $cseo_is_wp_mu ) . '<br />
';

		if (get_option( CXXX_SEED )) {
			echo CXXX_SEED . ': ' . get_option( CXXX_SEED ) . '<br />
';
		}

		$path = cseo_get_synonym_table(  );

		if ($path != 'n\a') {
			echo '<br />
';
			echo '<b>Replacement table:</b><br /><textarea cols="80" rows="20" wrap="off" style="margin:0;height:30em;width:100%;">
';
			foreach ($cseo_synonyms as $line) {
				echo $line . '
';
			}

			echo '</textarea><br />';
			echo 'Path: ' . $path;
		}

		exit(  );
	}


	if (!defined( 'CXXX_ALLOW_RSS_FEEDS' )) {
		if (get_option( CXXX_FEEDS_ALLOWED ) !== false) {
			define( 'CXXX_ALLOW_RSS_FEEDS', get_option( CXXX_FEEDS_ALLOWED ) );
		} 
else {
			define( 'CXXX_ALLOW_RSS_FEEDS', 1 );
		}
	}


	if (!defined( 'CXXX_ALLOW_UPGRADE' )) {
		define( 'CXXX_ALLOW_UPGRADE', 1 );
	}


	if (is_admin(  )) {
		cseo_preset_options(  );
	}

	$cseo_syndicator = new CyberSEO_Syndicator(  );
	$cseo_comment_campaigns = get_option( CXXX_COMMENT_CAMPAIGNS );
	$cseo_seed = get_option( CXXX_SEED );
	$cseo_server_mode = get_option( CXXX_SERVER_MODE );
	$cseo_standalone_mode = get_option( CXXX_STANDALONE_MODE );
	$cseo_hide_images = get_option( CXXX_HIDE_IMAGES );
	$cseo_urls_nofollow = get_option( CXXX_URLS_NOFOLLOW );
	$cseo_urls_target_blank = get_option( CXXX_URLS_TARGET_BLANK );
	$cseo_img_cloaking_mode = get_option( CXXX_IMG_CLOAKING_MODE );
	$cseo_img_cloaking_path = get_option( CXXX_IMG_CLOAKING_PATH );
	$cseo_fake_guids = get_option( CXXX_FAKE_GUIDS );
	$cseo_rss_pull_mode = get_option( CXXX_RSS_PULL_MODE );
	$cseo_sc_options = get_option( CXXX_SPINNERCHIEF_OPTIONS );
	$cseo_sr_options = get_option( CXXX_SPINREWRITER_OPTIONS );
	$cseo_sp_options = get_option( CXXX_SPINCHIMP_OPTIONS );
	cseo_assign_morphing_syntax_rules(  );

	if (is_admin(  )) {
		if (isset( $_POST['export_feeds'] )) {
			if (isset( $_POST['feed_ids'] )) {
				header( 'Content-Description: File Transfer' );
				header( 'Content-Disposition: attachment; filename=' . sanitize_key( get_bloginfo( 'name' ) ) . '-feed-settings.dat' );
				header( 'Content-Type: text/xml; charset=' . get_option( 'blog_charset' ), true );
				$cseo_syndicator->serializeFeeds( $_POST['feed_ids'] );
				exit(  );
			}
		}
	}

	register_deactivation_hook( __FILE__, 'cseo_deactivation' );
	add_filter( 'cron_schedules', 'cseo_add_cuctom_cron_interval' );

	if (( isset( $_GET['pull-feeds'] ) && $_GET['pull-feeds']  = get_option( CXXX_CRON_MAGIC ) )) {
		if (!is_admin(  )) {
			require_once( ABSPATH . 'wp-admin/includes/taxonomy.php' );
			add_action( 'shutdown', 'cseo_update_feeds' );
			return 1;
		}
	} 
else {
		if (( isset( $_GET['command'] ) || isset( $_GET[get_option( CXXX_CRON_MAGIC )] ) )) {
			$cseo_syndicator->runCommand( strtolower( $_GET['command'] ) );
		}


		if (( !cseo_check_serial( false ) || $cseo_seed   = false )) {
			add_action( 'admin_menu', 'cseo_activation_menu' );
			return 1;
		}


		if (is_admin(  )) {
			add_action( 'admin_menu', 'cseo_main_menu' );
			add_action( 'before_delete_post', 'cseo_delete_post_images' );
			add_filter( 'content_edit_pre', 'cseo_content_edit_pre' );
			add_filter( 'sanitize_title', 'cseo_sanitize_title', 2 );
			remove_action( 'publish_post', 'generic_ping' );
			remove_action( 'do_pings', 'do_all_pings', 10, 1 );
			remove_action( 'publish_post', '_publish_post_hook', 5, 1 );
			add_action( 'publish_post', 'cseo_generic_ping' );
			return 1;
		}


		if (get_option( CXXX_LINK_TO_SOURCE )  = 'on') {
			add_filter( 'post_link', 'cseo_permalink', 1 );
		}


		if (strpos( $cseo_rss_pull_mode, 'auto' ) !== false) {
			if (function_exists( 'wp_next_scheduled' )) {
				add_action( 'update_by_wp_cron', 'cseo_update_feeds' );

				if (!wp_next_scheduled( 'update_by_wp_cron' )) {
					wp_schedule_event( time(  ), cseo_get_cuctom_cron_interval_name(  ), 'update_by_wp_cron' );
				}
			} 
else {
				add_action( 'shutdown', 'cseo_update_feeds' );
			}
		} 
else {
			if (( function_exists( 'wp_clear_scheduled_hook' ) && wp_next_scheduled( 'update_by_wp_cron' ) )) {
				wp_clear_scheduled_hook( 'update_by_wp_cron' );
			}
		}


		if ($cseo_fake_guids  = 'on') {
			add_filter( 'get_the_guid', 'cseo_fake_guid' );
		}


		if (( ( $cseo_standalone_mode  = 'on' || $cseo_server_mode  = 'on' ) || $cseo_img_cloaking_mode  = 'on' )) {
			add_filter( 'the_content', 'cseo_runtime_post_morphing', 2 );
			add_filter( 'the_title', 'cseo_runtime_title_morphing', 2 );
			add_filter( 'wp_title', 'cseo_runtime_title_morphing' );
			add_filter( 'the_excerpt', 'cseo_runtime_post_morphing', 2 );
			add_filter( 'the_excerpt_rss', 'cseo_excerpt_rss', 1 );
		} 
else {
			if (( ( $cseo_hide_images  = 'on' || $cseo_urls_nofollow  = 'on' ) || $cseo_urls_target_blank  = 'on' )) {
				add_filter( 'the_content', 'cseo_runtime_post_morphing', 2 );
				add_filter( 'the_excerpt', 'cseo_runtime_post_morphing', 2 );
			}
		}


		if (isset( $_GET['custom_tags'] )) {
			add_action( 'rss2_item', 'cseo_rss2_item' );
		}


		if (count( $cseo_comment_campaigns )) {
			add_filter( 'the_content', 'cseo_auto_comment', 3 );
		}


		if (!CXXX_ALLOW_RSS_FEEDS) {
			add_filter( 'the_content', 'cseo_shrink_feed', 100 );
			add_filter( 'the_excerpt', 'cseo_shrink_feed', 100 );
			add_filter( 'the_excerpt_rss', 'cseo_shrink_feed', 100 );
			add_filter( 'the_content_rss', 'cseo_shrink_feed', 100 );
		}
	}

?>