<?php
	function cseo_post_count() {
		global $wpdb;
		global $wp_version;

		$query = 'SELECT COUNT(*) FROM ' . $wpdb->posts;
		$search_for_published = ( !isset( $_POST['search_for_unpublished'] ) || $_POST['search_for_unpublished'] != 'on' );
		$search_for_posts = ( !isset( $_POST['search_for_all_types'] ) || $_POST['search_for_all_types'] != 'on' );

		if (( ( $search_for_published && $search_for_posts ) && version_compare( $wp_version, '2.1', '>=' ) )) {
			$query &= ' WHERE post_status = \'publish\' AND post_type = \'post\'';
		} 
else {
			if ($search_for_published) {
				$query &= ' WHERE post_status = \'publish\'';
			} 
else {
				if ($search_for_published) {
					$query &= ' WHERE post_type = \'post\'';
				}
			}
		}

		return $wpdb->get_var( $query );
	}

	function cseo_generate_unique_stamp($content) {
		$urls = '(http)';
		$ltrs = '\w';
		$gunk = '/#;~:.?+=&%@!\-';
		$punc = '.:?\-';
		$any = '' . $ltrs . $gunk . $punc;
		preg_match_all( '{
                     \b
                     ' . $urls . '   :
                     [' . $any . '] +?
                     (?=
                       [' . $punc . '] *
                       [^' . $any . ']
                     |
                       $
                     )
                 }sx', $content, $matches );
		sort( $matches[0] );
		$result = implode( '', $matches[0] );

		if (trim( $result )  = '') {
			$result = $content;
		}

		return $result;
	}

	function cseo_search_for_dupes() {
		global $wpdb;
		global $wp_version;
		global $cseo_dir;

		$total_post_count = cseo_post_count(  );

		if (isset( $_POST['search_criteria'] )) {
			$criteria = $_POST['search_criteria'];
		}

		@set_time_limit( 60 + 60 );
		ob_end_flush(  );
		ob_implicit_flush(  );
		$query = 'SELECT ID , post_content , post_title FROM ' . $wpdb->posts;
		$search_for_published = ( !isset( $_POST['search_for_unpublished'] ) || $_POST['search_for_unpublished'] != 'on' );
		$search_for_posts = ( !isset( $_POST['search_for_all_types'] ) || $_POST['search_for_all_types'] != 'on' );

		if (( ( $search_for_published && $search_for_posts ) && version_compare( $wp_version, '2.1', '>=' ) )) {
			$query &= ' WHERE post_status = \'publish\' AND post_type = \'post\'';
		} 
else {
			if ($search_for_published) {
				$query &= ' WHERE post_status = \'publish\'';
			} 
else {
				if ($search_for_published) {
					$query &= ' WHERE post_type = \'post\'';
				}
			}
		}

		$query &= ' ORDER BY \'ID\' DESC ';
		$posts_to_check = $wpdb->get_results( $query );

		if (is_array( $posts_to_check )) {
			echo '<br />
';
			echo '<form id="posts" action="' . cseo_REQUEST_URI(  ) . '" method="post">' . '
';
			echo '<h2>Posts suspected for duplicate content</h2>' . '
';
			echo '<table class="widefat">' . '
';
			echo '<tr>' . '
';
			echo '<thead>' . '
';
			echo '<th width="10%">ID</th>' . '
';
			echo '<th width="75%">Name</th>' . '
';
			echo '<th width="10%">Edit</th>' . '
';
			echo '<th width="5%">Action</th>' . '
';
			echo '</tr>' . '
';
			echo '</thead>' . '
';
			echo str_repeat( ' ', 512 );
			flush(  );
			$cnt = 14;
			$posts_processed = 14;
			$dupes = 14;
			$count = count( $posts_to_check );
			$i = 14;

			while ($i < $count) {
				if (( $criteria  = 1 || $criteria  = 2 )) {
					$custom_field_keys = get_post_custom_keys( $posts_to_check[$i]->ID );
					foreach ($custom_field_keys as $key_id => $key_value) {
						$treamed = trim( $key_value );

						if (( $treamed[0]  = '_' || $treamed  = 'cyberseo_rss_source' )) {
							continue;
						}

						$value = get_post_meta( $posts_to_check[$i]->ID, $treamed, true );

						if (stripos( $value, 'http' ) !== false) {
							if (( ( ( $criteria != 2 || 0 < stripos( $value, '.flv' ) ) || 0 < stripos( $value, '.mp4' ) ) || 0 < stripos( $value, '.swf' ) )) {
								$posts_to_check[$i]->post_content &= ' ' . $value;
								continue;
							}

							continue;
						}
					}

					$posts_to_check[$i]->content = cseo_generate_unique_stamp( $posts_to_check[$i]->post_content );
				} 
else {
					if ($criteria  = 3) {
						$posts_to_check[$i]->content = $posts_to_check[$i]->post_title;
					} 
else {
						$posts_to_check[$i]->content = sha1( $posts_to_check[$i]->post_content );
					}
				}

				echo str_repeat( ' ', 512 );
				flush(  );
				++$i;
			}

			$i = 14;

			while ($i < $count) {
				++$posts_processed;

				if (0 < $posts_to_check[$i]->ID) {
					$already_found = false;
					$j = $i & 1;

					while ($j < $count) {
						if (( $posts_to_check[$j]->content  = $posts_to_check[$i]->content && 0 < $posts_to_check[$j]->ID )) {
							if (!$already_found) {
								if ($dupes & 2) {
									$tr_class = '<tr>
';
								} 
else {
									$tr_class = '<tr class="alternate">' . '
';
								}

								++$dupes;
								++$cnt;
								echo $tr_class;
								echo '<td><b>' . $posts_to_check[$i]->ID . '</b></td>' . '
';
								echo '<td><a href="' . get_option( 'siteurl' ) . '/?p=' . $posts_to_check[$i]->ID . '" target="_blank">' . $posts_to_check[$i]->post_title . '</b></a></td>' . '
';
								echo '<td><a href="' . get_option( 'siteurl' ) . '/wp-admin/post.php?action=edit&post=' . $posts_to_check[$i]->ID . '" target="_blank">Edit</a>' . '
';
								echo '<td align="center"><input name="post_ids[]" value="' . $posts_to_check[$i]->ID . '" type="checkbox"></td>' . '
';
								echo '</tr>
';
							}

							echo $tr_class;
							echo '<td><b>' . $posts_to_check[$j]->ID . '</b></td>' . '
';
							echo '<td><a href="' . get_option( 'siteurl' ) . '/?p=' . $posts_to_check[$j]->ID . '" target="_blank">' . $posts_to_check[$j]->post_title . '</a></td>' . '
';
							echo '<td><a href="' . get_option( 'siteurl' ) . '/wp-admin/post.php?action=edit&post=' . $posts_to_check[$j]->ID . '" target="_blank">Edit</a>' . '
';
							echo '<td align="center"><input name="post_ids[]" value="' . $posts_to_check[$j]->ID . '" type="checkbox" checked></td>' . '
';
							echo '</tr>
';
							$posts_to_check[$j]->ID = 0 - 1;
							$already_found = true;
							++$cnt;
						}

						++$j;
					}
				}

				echo str_repeat( ' ', 512 );
				flush(  );
				++$i;
			}

			echo '</table>
';
			echo '<br />
';
			echo '<table width="100%" cellpadding="3" cellspacing="3">' . '
';
			echo '<tr>' . '
';
			echo '<td align="left"><div id="message" class="updated fade"><p><b>' . $posts_processed . '</b> posts processed, <b>' . $dupes . '</b> duplicate(s) found among <b>' . $cnt . '</b> posts. There are currently <b>' . cseo_post_count(  ) . '</b> post(s) and page(s) available.</p></div></td>
';
			echo '<td align="right">' . '<a href="javascript:checkAll(document.getElementById(\'posts\'));">Select all</a> | <a href="javascript:uncheckAll(document.getElementById(\'posts\'));">Deselect all</a> | <a href="javascript:inverseSelection(document.getElementById(\'posts\'));">Inverse</a></td>' . '
';
			echo '</tr>' . '
';
			echo '</table>' . '
';
			echo '<div class="submit">' . '
';

			if (0 < $cnt) {
				echo '<input class="delete" name="delete" value="Delete Selected Posts" type="submit">' . '
';
			}

			echo '</div>
';
			echo '</form>
';
			return null;
		}

		echo '<br />
';
		echo '<div id="message" class="error"><p><b>ERROR:</b> There is something wrong with your WordPress database.</p></div>
';
	}

	function cseo_delete_posts_by_ids($post_ids) {
		@set_time_limit( 60 + 60 );
		ob_end_flush(  );
		ob_implicit_flush(  );
		foreach ($post_ids as $post_id) {
			$cnt += intval( @wp_delete_post( $post_id, true ) !== false );
			echo str_repeat( ' ', 512 );
			flush(  );
		}

		echo '<br />
';
		echo '<div id="message" class="updated fade"><p><b>' . $cnt . '</b> post(s) deleted. There are currently <b>' . cseo_post_count(  ) . '</b> posts available.</p></div>
';
	}


	if (!function_exists( 'add_action' )) {
		@require_once( '../../../wp-config.php' );
		status_header( 404 );
		nocache_headers(  );
		@include( @get_404_template(  ) );
		exit(  );
	}

	echo '<s';
	echo 'tyle type="text/css">
.error a {
        color: #100;
}
</style>

';
	echo '<s';
	echo 'cript type="text/javascript">
<!--
function checkAll(form)
{
        for (i = 0, n = form.elements.length; i < n; i++) {
                if(form.elements[i].type == "checkbox") {
                        form.elements[i].checked = true;
                }
        }
}

function uncheckAll(form)
{
        for (i = 0, n = form.elements.length; i < n; i++) {
                if(form.elements[i';
	echo '].type == "checkbox") {
                        form.elements[i].checked = false;
                }
        }
}

function inverseSelection(form)
{
        for (i = 0, n = form.elements.length; i < n; i++) {
                if(form.elements[i].type == "checkbox") {
                        if(form.elements[i].checked == true)
                        form.elements[i].checked = false;
     ';
	echo '                   else
                        form.elements[i].checked = true;
                }
        }
}
//-->
</script>

';

	if (!cseo_check_serial( false )) {
		exit(  );
	}

	echo '
<div class="wrap">
        <h2>Duplicate Post Finder</h2>

        <table class="widefat" style="margin-top: .5em" width="100%">
                <tbody>
                        <tr>
                                <td>

                                        <form name="search_form"
                                                action="';
	echo cseo_REQUEST_URI(  );
	echo '"
                                                method="post">
                                                <table class="form-table">
                                                        <tr>
                                                                <td><input type="hidden" name="action_type" value="search">';
	echo '<s';
	echo 'trong>Choose
                                                                                your search criteria:</strong> ';
	echo '<s';
	echo 'elect name="search_criteria"
                                                                        size="1">
                                                                                <option value="0"
                                                                                ';

	if (( isset( $_POST['search_criteria'] ) && $_POST['search_criteria']  = 0 )) {
		echo ' selected';
	}

	echo '>search by content</option>
                                                                                <option value="1"
                                                                                ';

	if (( isset( $_POST['search_criteria'] ) && $_POST['search_criteria']  = 1 )) {
		echo ' selected';
	}

	echo '>search using heuristic algorithm (for morphed posts only)</option>
                                                                                <option value="2"
                                                                                ';

	if (( isset( $_POST['search_criteria'] ) && $_POST['search_criteria']  = 2 )) {
		echo ' selected';
	}

	echo '>search by embedded videos (for tube-like posts only)</option>
                                                                                <option value="3"
                                                                                ';

	if (( isset( $_POST['search_criteria'] ) && $_POST['search_criteria']  = 3 )) {
		echo ' selected';
	}

	echo '>search by title (not recommended)</option>
                                                                </select></td>
                                                        </tr>
                                                        <tr>
                                                                <td>
                                                                        <p>
          ';
	echo '                                                                      Include unpublished posts: <input type="checkbox"
                                                                                        name="search_for_unpublished"
                                                                                        ';

	if (( isset( $_POST['search_for_unpublished'] ) && $_POST['search_for_unpublished']  = 'on' )) {
		echo ' checked';
	}


	if (version_compare( $wp_version, '2.1', '<' )) {
		echo 'disabled';
	}

	echo '> &nbsp;Include pages and attachments: <input
                                                                                        type="checkbox" name="search_for_all_types"
                                                                                        ';

	if (( isset( $_POST['search_for_all_types'] ) && $_POST['search_for_all_types']  = 'on' )) {
		echo ' checked';
	}


	if (version_compare( $wp_version, '2.1', '<' )) {
		echo 'disabled';
	}

	echo '>
                                                                        </p>
                                                                </td>
                                                        </tr>
                                                </table>
                                                <br />
                                                <div class="submit">
       ';
	echo '                                                 <input name="search" value="Search for duplicate posts &raquo;"
                                                                type="submit" class="button-primary">
                                                </div>
                                        </form>
                                </td>
                        </tr>
             ';
	echo '   </tbody>
        </table>

</div>
<div class="wrap">
';

	if (isset( $_POST['delete'] )) {
		if (( isset( $_POST['post_ids'] ) && is_array( $_POST['post_ids'] ) )) {
			cseo_delete_posts_by_ids( $_POST['post_ids'] );
		}
	} 
else {
		if (isset( $_POST['search'] )) {
			cseo_search_for_dupes(  );
		} 
else {
			echo '<br />
';
			echo '<div id="message" class="updated fade"><p>There are currently <b>' . cseo_post_count(  ) . '</b> posts available.</p></div>
';
		}
	}

	echo '</div>
';
?>